C======================================================================
      Program EVCLID
C======================================================================
C     A Geometric Calculator and Editor
C     by Hanno Essen, revision of March 1992 (KTH, Stockholm)
C     originally developed at Mcmaster University,Hamilton,Ont.,Canada,1982
C----------------------------------------------------------------------
      call main
      end
 C====================================================================== 
      subroutine main
      include 'common.inc'
C---------------------------------------------------------------------
C     Declarations:
      logical ifx(+360), ifz,  ifh, ifc
C ifx(n)=.true. if atom number n has been entered. 
C ifz=.true. if atomic numbers Z have been entered.
C ifh=.true. if help command was read by routine readin
C ifc=.true. if a command was found in readin
      integer nq(+360), nnq(+360), mz(+360,3), imz(+360), nxz
      integer nx, lnmx,  lfn,mxn,noa, nnh, nmz,  last, i, maccnt
C nq(n) contains atomic number Z of atom n.
C nnq(n) contains a count of atoms with the same Z.
C mz(n,3) contains the z-matrix reference atoms i,j,k of atom n
C imz(n)= 0 if no z-matrix info for atom n, 1 if normal, -1 if alternative
      double precision a(+360,3), cnzs(+361)
C a(n,3) contains the cartesian coordinates of entered atom number n.
C conv is the conversion factor degrees to radians. 
C cnzs(n) contains numerical z-matrix constants of symbolic z-matrix
      character comm*4,x*1,yz*2, str*80,prmp*79,numbst*3
C symbs contains the symbols in symbolic z-matrices, consts the numbers
      character symbs(+361)*20, consts(+361)*25
C--------------------------------------------------------------------
C nx= basic array dimension (max no of atoms). Change above and here :
      nx=+360
C lnmx= max no of output lines on screen.
      lnmx=22
C nxz= max no of symbols in symbolic z-matrix (used in izmcom and ozmcom)
      nxz=+361
C--------------------------------------------------------------------
      prmp=' Evclid, a geometric calculator and editor by H. Essen'
      prmp(68:79)='version:1995'
      write(6,*) prmp
C Initialize conv and arrays nq, ifx and imz
      conv=dacos(-1.D0)/180.D0
      mz(3,3)=0
      do 1 i=1,nx
         nnq(i)=i
         nq(i)=1
         ifx(i)=.false.
         imz(i)=0
 1    continue
C Initialize ifc,  lfn, mxn, noa and nmz, and nnh, ifz
      ifc=.false.
      call naccnt(nx,ifx,lfn,mxn,noa)
      nmz= maccnt(nx,imz)
      call caccnt(nx,ifx,nq,nnq,mxn,nnh,ifz)
C     
      prmp=' Type:command      (h = help,  hh = basic help)'
      go to 93
C Come back here if command was not recognized
 90   continue
C     
C Return to this point after visit to option subroutine or help-writeout
 91   continue
C Command returned from subroutine readin is in  str
      if(ifc) then
         comm=str(1:4)
         ifc=.false.
         go to 80
      endif
      prmp='Type:command'
      if(noa.gt.0) then
         prmp=prmp(1:12)//'   (no of atoms:'//numbst(noa)
         call strip(prmp,last)
         prmp=prmp(1:last)//')'
      endif
      if(nnh.gt.0) then
         call strip(prmp,last)
         prmp=prmp(1:last)//'  (no of Z >1: '//numbst(nnh)
         call strip(prmp,last)
         prmp=prmp(1:last)//')'
      endif
      if(nmz.gt.0) then
         call strip(prmp,last)
         prmp=prmp(1:last)//' (z-mtx rows:'//numbst(nmz)
         call strip(prmp,last)
         prmp=prmp(1:last)//')'
      endif
      prmp=' '//prmp
 93   prmp(75:79)='?xyz?'
      write(6,*) prmp
 930  str(1:4)='Evc>'
      call readin(ifc,str,last,ifh)
      if(str.eq.'file-end') go to 930
      if(str.eq.'assgmnt=') go to 93
      ifc=.false.
      if(last.gt.4) go to 92
      if(last.eq.0) then
         if(noa.eq.0) then
            write(6,*) ' To terminate run type: quit'
            go to 90
         elseif(noa.ne.0) then
            str='dco '
            last=3
         endif
      endif
      comm=str(1:last)
      if(comm.eq.'help') comm='hh '
C     
C Put non-standard abbreviations on standard form
      if(comm.eq.'c   ') comm='ico '
      if(comm.eq.'s   ') then
         if(noa.gt.0) comm='osa '
         if(noa.eq.0.and.(.not.ifz).and.nmz.eq.0) comm='isa '
         if(comm.eq.'s   ') then
            write(6,*) 
     +           ' Zero atoms but not empty.  Specify: isa  or: osa !?'
            go to 91
         endif
      endif
      if(comm.eq.'r   ') comm='erm '
      if(comm(4:4).ne.' ') go to 92
C
 80   x=comm(1:1)
      yz=comm(2:3)
      if(noa.eq.0.and.(x.ne.'i'.and.x.ne.'h'.and.yz.ne.'h ')) 
     +     write(6,*)' When zero atoms option should be of input-type.'
C
C When the command xyz has been given a subroutine with the name
C            subroutine xyzcom
C is called. It issues a prompt for input parameters and when its task
C is finished control is returned to the main program (top level).
      if(x.eq.'i') then
         if(yz.eq.'  '.or.yz.eq.'ge'.or.yz.eq.'g ') then
            call igecom(str,ifc,nx,ifx,a,noa)
         elseif(yz.eq.'co'.or.yz.eq.'c ') then
            call icocom(str,ifc,nx,ifx,a,lfn,mxn,noa,nmz,imz)
         elseif(yz.eq.'po'.or.yz.eq.'p ') then
            call ipocom(str,ifc,nx,ifx,nq,a,mxn,ifz)
         elseif(yz.eq.'an'.or.yz.eq.'a ') then
            call iancom(str,ifc,nx,ifx,nq,noa,ifz)
         elseif(yz.eq.'sa') then
            call isacom(str,ifc,nx,ifx,nq,a,noa,mxn,ifz,nnh,nmz,imz,mz)
         elseif(yz.eq.'cf') then
            call icfcom(str,ifc,nx,ifx,nq,a,ifz,mxn)
         elseif(yz.eq.'zm'.or.yz.eq.'z ') then
            call izmcom(str,ifc,nx,ifx,nq,a,ifz,
     +           imz,mz,mxn,symbs,nxz,consts)
         elseif(ifh) then
            write(6,1001)
            write(6,1002)
         else
            go to 92
         endif
C
      elseif(x.eq.'d')then
         if(yz.eq.'  '.or.yz.eq.'co'.or.yz.eq.'c ') then
            call dcocom(str,ifc,nx,ifx,nq,nnq,a,mxn,ifz,lnmx)
         elseif(yz.eq.'zm'.or.yz.eq.'z ') then
            call dzmcom(str,ifc,nx,ifx,nq,nnq,a,mxn,ifz,lnmx,nmz,imz,mz)
         elseif(yz.eq.'ge'.or.yz.eq.'g ') then
            call dgecom(str,ifc,nx,ifx,nq,nnq,a,mxn,ifz,lnmx)
         elseif(ifh) then
            write(6,1003)
         else
            go to 92
         endif
C
      elseif(x.eq.'o')then
         if(yz.eq.'  '.or.yz.eq.'zm'.or.yz.eq.'z ') then
            if(.not.ifz) write(6,*)' ** Don''t forget atomic charges **'
            call ozmcom(str,ifc,nx,ifx,nq,nnq,a,mxn,
     +           imz,mz,symbs,nxz,cnzs)
         elseif(yz.eq.'cf'.or.yz.eq.'co'.or.yz.eq.'c ') then
            call ocfcom(str,ifc,nx,ifx,nq,nnq,a,mxn,ifz)
         elseif(yz.eq.'sa') then
            call osacom(nx,ifx,nq,a,noa,mxn,ifz,nnh,nmz,imz,mz)
         elseif(ifh) then
            write(6,1004)
            write(6,1024)
         else
            go to 92
         endif
C
      elseif(x.eq.'g')then
         if(yz.eq.'  '.or.yz.eq.'pr'.or.yz.eq.'p ') then
            call gprcom(str,ifc,nx,ifx,nq,a,mxn)
         elseif(yz.eq.'tr'.or.yz.eq.'t ') then
            call gtrcom(str,ifc,nx,ifx,nq,a,mxn)
         elseif(yz.eq.'ro'.or.yz.eq.'r ') then
            call grocom(str,ifc,nx,ifx,nq,a,mxn)
         elseif(yz.eq.'sc') then
            call gsccom(str,ifc,nx,ifx,nq,a,mxn)
         elseif(yz.eq.'re') then
            call grecom(str,ifc,nx,ifx,nq,a,mxn)
         elseif(yz.eq.'in') then
            call gincom(str,ifc,nx,ifx,nq,a,mxn)
         elseif(ifh) then
            write(6,1051)
            write(6,1052)
         else
            go to 92
         endif
C
      elseif(x.eq.'e')then
         if(yz.eq.'  '.or.yz.eq.'mo'.or.yz.eq.'m ') then
            call emocom(str,ifc,nx,ifx,nq,a,mxn)
         elseif(yz.eq.'or'.or.yz.eq.'o ') then
            call eorcom(str,ifc,nx,ifx,nq,a,mxn,ifz)
         elseif(yz.eq.'pe'.or.yz.eq.'p ') then
            call epecom(str,ifc,nx,ifx,nq,a,mxn)
         elseif(yz.eq.'rr'.or.yz.eq.'r ') then
            call errcom(str,ifc,nx,ifx,nq,a,mxn)
         elseif(yz.eq.'rm'.or.yz.eq.'d ') then
            call ermcom(str,ifc,nx,ifx,nq,mxn,ifz,imz)
         elseif(yz.eq.'cp'.or.yz.eq.'c ') then
            call ecpcom(str,ifc,nx,ifx,nq,a,mxn)
         elseif(yz.eq.'zm'.or.yz.eq.'z ') then
            call ezmcom(str,ifc,nx,ifx,nq,a,mxn,nmz,imz,mz)
         elseif(ifh) then
            write(6,1006)
         else
            go to 92
         endif
C
      elseif(x.eq.'h') then
         if(yz.eq.'  ') then
            write(6,901)
            write(6,902) nx
         elseif(yz.eq.'h ') then
            write(6,1901)
            write(6,1902)
         elseif(yz.eq.'i ') then
            write(6,1001)
            write(6,1002)
         elseif(yz.eq.'d ') then
            write(6,1003)
         elseif(yz.eq.'o ') then
            write(6,1004)
            write(6,1024)
         elseif(yz.eq.'g ') then
            write(6,1051)
            write(6,1052)
         elseif(yz.eq.'e ') then
            write(6,1006)
         else
            go to 92
         endif
      else
         go to 92
      endif
C     
       if(x.eq.'i'.or.x.eq.'g'.or.x.eq.'e') then
          call naccnt(nx,ifx,lfn,mxn,noa)
          if(noa.eq.nx) write(6,*) ' Warning, atom storage full !'
          nmz= maccnt(nx,imz)
          call caccnt(nx,ifx,nq,nnq,mxn,nnh,ifz)
          if(noa.eq.0) go to 91
C Coordinates with very small absolut value 
C are assumed to be non-zero by accident, so they are set to zero.
          do 2 i=1,mxn
             if(.not.ifx(i)) go to 2
             if(dabs(a(i,1)).lt.1.D-8) a(i,1)=0.D0
             if(dabs(a(i,2)).lt.1.D-8) a(i,2)=0.D0
             if(dabs(a(i,3)).lt.1.D-8) a(i,3)=0.D0
 2        continue
       endif
       go to 91
C Go back and ask for new command
 92    write(6,*)' Command not recognized.  For help type: h'
       go to 90
C Go back to beginning and remind of the help option
C                                       below only format text  *end*
C---------------------------------------------------------------------
 901  format('              COMMAND MENU              '/
     +'   A *command* has the form:xyz  where  x  specifies the type'/
     +' of option and  yz  the specific option as follows: '/
     +'   x=i (Input)      yz=(ge) co po an h   (from file:) sa cf zm '/
     +'   x=d (Display)    yz=(co) zm ge h'/
     +'   x=o (Output)     yz=(zm) cf sa h              (default:(yz))'/
     +'   x=g (Geometric)  yz=(pr) tr ro sc re in h'/
     +'   x=e (Edit)       yz=(mo) or pe rr rm cp zm h'/
     +'   x=h (Help)       yz=(  ) i  d  o  g  e  h    (for more Help)'/
     +'  ABBREVIATIONS: (ido)  ge =Geometric par',
     +'ameters, co =Coordinates, po =Polygon'/
     +' or Polyhedron, an =Atomic Number, sa =Save',
     +', cf =Coordinate File, zm =Z-Matrix.')
 902  format(
     +' (g)   pr =Principal axes, tr =Translate,',
     +' ro =Rotate, sc =Scale, re =Reflect,  '/
     +' in =Invert.   (e)   mo =Move, or =Order, ',
     +'pe =Permute, rr =Remove & Renumber, '/
     +' rm =Remove, cp =Copy, zm =Z-Matrix.      ',
     +'          **  to stop Type: quit  **'//
     +'     General   NOTATION    in prompts:'/
     +' n  or  m,n  stand for Number(s) (max:',i3,
     +                                       ') assigned (or to be '/
     +'        assigned) to atoms at input by user or automatically.'/
     +' nf,nl  stand for a range of atoms these being the Numbers of'/    
     +'        the First and Last atoms in the range, respectively.'/
     +' ct     denotes Coordinate Type:x =Cartesian, c =Cylindrical '/
     +'        and s =Spherical (polar) coordinates.')
 1901 format('   BASIC HELP ABOUT EVCLID                            '/
     +'  The program works on an array of Cartesian coordinates of'/
     +' points. One can *Input  points to this array in various ways'/
     +' and once this has been done one can *Display  properties of'/
     +' the point set on the screen or *Output  such to file. One can'/
     +' manipulate the point set with *Geometric operations or with'/
     +' *Edit options (copy, remove, renumber). At the top level you'/
     +' can get *Help with one of the following commands:'/
     +'  h    for command menu           hi   for input-commands'/
     +'  hd   for display-commands       ho   for output-commands'/
     +'  hg   for geometric-commands     he   for edit-commands'/
     +'  hh   for the present text')
 1902 format(
     +'  Once you have selected and given a command:xyz you will get'/
     +' a prompt something like:'/
     +' Enter:a1 (a2)... etc.  (& a..)                (h = help) ',
     +'                *xyz*'/
     +' which tells you what arguments the command expects. Now you'/
     +' can enter: h for an explanation of what the argument symbols'/
     +' stand for. This information is maximum one screen long and'/
     +' then the prompt for input,  Enter:. etc., appears again.'/
     +' Note that the number of arguments is important and deter-'/
     +' mines the action taken. Input lines always end with return.'/
     +' Arguments in parenthesis are optional.')
 1001 format('         INPUT FROM TERMINAL      '/
     +'   Input of atoms from the terminal can be done using:'/
     +' Geometric parameters (distances, angles, dihedral angles)'/
     +' referencing already entered atoms;     command:ige  (i) '/
     +' or using Coordinates;                  command:ico  (c) '/
     +'   Make Polygon or Polyhedron with      command:ipo  (ip) '/
     +' Atomic Numbers can be entered with     command:ian  (ia)'/
     +'   When you have entered the command a prompt-line will appear'/
     +' which tells you what input will be accepted. If you still'/
     +' don''t understand you can type:h for an explanation.'/
     +'                           (Short command-form in parenthesis)')
 1002 format('         INPUT FROM FILE            '/
     +'   If the command:s (or:osa) has been given earlier to Save in-'/
     +' put this input will come back with     command:isa  (s)'/
     +' When the program is empty the command:s is taken to mean:isa'/
     +' otherwise it means:osa. Note that the command:isa removes all'/
     +' current contents before it puts back what was stored at save.'/
     +'   To read files containing:'/
     +' charges and Cartesian coordinates;     command:icf '/
     +' charges and Z-matrix;                  command:izm  (iz)'/
     +'   The z-matrix concept is explained if you give command:dzm'/
     +' and then type:h. (See also: ho for information on save.)')
 1003 format('            DISPLAY OPTIONS         '/
     +' Display of Coordinates,          command:dco  ( )'/
     +' Display of Z-matrix,             command:dzm  (dz)'/
     +' Display of Geometric parameters, command:dge  (dg)'/
     +'                          (Short command form in parenthesis) '/
     +'   After the command has been typed a prompt line will appear.'/
     +' No input is needed for the standard (default) display, just'/
     +' press return and the information will appear on the screen.'/
     +' As usual you can always type:h for help.'/
     +'   For coordinates the default is Cartesian coordinates'/
     +' (else you must give coordinate type:ct  as c or s).'/
     +'   A z-matrix is a set of 3N-6 geometric parameters that give'/
     +' the shape of the N-atom set in a coordinate independent way.'/
     +'   Lists of geometric parameters running over all pairs of'/
     +' atoms are generated with:dge. The default parameter type is'/
     +' distance. Give the command and type:h for further information.'/
     +'   One can always give a range: nf,nl to limit display.'/
     +' To cancel display you must type:q (just return will not work).')
 1004 format('         OUTPUT TO FILE               '/
     +'   Output options are     command:ozm  (o)    for Z-matrix'/
     +' and                      command:ocf  (oc)   for Coordinates'/
     +'                      (short command form in parenthesis)'/
     +'   You will be asked for a name for the output file the first'/
     +' time the command is given (it must be a new name).'/
     +'   The lines written to the file are also displayed on the'/
     +' screen. Each time the commands are called and lines appear on'/
     +' the terminal screen corresponding lines are added at the end'/
     +' of the output file (because no rewind is done).'/
     +'   In a subsequent run the output files can be read back in'/
     +' with: izm  or: icf  but the standard restart should be Save.')
 1024 format('         ABOUT SAVE'/
     +'   To save all your input to the program at a given time,'/
     +' just type: s  When there are entered atoms this is short for'/ 
     +'                          command:osa  (s)    for Save'/
     +' The output is written to file: ecldsv.dat and can be read back'/
     +' in later in the same or a subsequent run with command:isa.'/
     +' Each time you give the command s (or osa) output is written to'/
     +' the end of the file ecldsv.dat. When the program is empty  s'/
     +' will mean  isa  and the output of the last save is read in.'/
     +' Otherwise isa issues a prompt which asks which save you wish.')
 1051 format(
     +'   The default GEOMETRIC option is a transformation to a'/
     +' natural molecular coordinate-system: the origin is posi-'/
     +' tioned at the center of charge, and the axes are made Princi-'/
     +' pal axes i.e. eigenvectors of the (charge-)inertia tensor.'/
     +' In a symmetric molecule this system is often a natural sys-'/
     +' tem. A symmetry-axis becomes z-axis.'/
     +'                  Principal axes        command:gpr  (g) '/
     +'   The continuous transformations translation, rotation and'/
     +' scaling are optionally performed on a copy. The commands are:'/
     +'                  Translation           command:gtr  (gt)'/
     +'                  Rotation              command:gro  (gr)'/
     +'                  Scaling               command:gsc')
 1052 format(
     +'   It is also possible to perform reflection or inversion.'/
     +' These are performed on a copy unless otherwise requested.'/
     +' The commands for these operations are:'/
     +'                  Reflection            command:gre'/
     +'                  Inversion             command:gin'/
     +'   All these options accept input of  nf, nl  the range to'/
     +' be affected by the operation. In:gpr  one can also, if'/
     +' desired, specify a (different) range: ndf, ndl  to define'/
     +' the new origin and axes. Further Help available after the '/
     +' appropriate command has been given.')
 1006 format('                EDIT OPTIONS                 '//
     +' The available Edit options can be summarized as follows:'//
     +' EDIT OF ATOMS (and charges):'/
     +'     (0) RENUMBERING (permutational) options'/
     +' Move (with automatic renumbering)    command:emo  (e)'/
     +' Order (ct or an)                     command:eor  (eo)'/
     +' Permute                              command:epe  (ep)'/
     +'     (-) REMOVING options'/
     +' Remove & Renumber (to close gap)     command:err  (er) '/
     +' Remove (i.e. Delete)                 command:erm  (r)'/
     +'     (+) ADDING option'/
     +' Copy (a given range)                 command:ecp  (ec)'//
     +' EDIT OF Z-MATRIX'/
     +' Z-matrix (input, display, remove)    command:ezm  (ez)'//
     +'   When the command has been given a prompt will (as usual)'/
     +' appear. For all these commands one can then type:h for Help'/
     +' to get an explanation of the input and its effect.'/)
      end
