MODULE ErrorFun
  ! .. Global Variable Definitions ..
  INTEGER :: ErrOut = 6, ErrStat = 0
  LOGICAL :: ErrExit = .TRUE.

CONTAINS
  SUBROUTINE error (IError, RName, Message)
    ! .. Implicit none ..
    IMPLICIT NONE
    ! .. Scalar Arguments ..
    INTEGER, INTENT(in) :: IError
    CHARACTER(LEN=*), INTENT(in) :: RName, Message
    ! Print the appropriate error message
    IF (IError >= 300) THEN
       WRITE (ErrOut,'(2A)') 'ERROR in routine ',RName
    ELSE
       WRITE (ErrOut,'(2A)') 'WARNING in routine ',RName
    END IF
    WRITE (ErrOut,'(A)') Message

    IF (IError >= 300) THEN
       IF (ErrExit) THEN
          STOP
       ELSE
          ErrStat = IError
       END IF
    END IF
    RETURN
  END SUBROUTINE error
END MODULE ErrorFun


