MODULE HPF_FUNC

  USE precision
  
CONTAINS
FUNCTION hpf_add_s1 (A, B)
  IMPLICIT NONE



  REAL(sp), INTENT(in) :: A(:), B(:)
  REAL(sp), DIMENSION(SIZE(A)) :: hpf_add_s1


  hpf_add_s1 = A + B
  RETURN
END FUNCTION hpf_add_s1
FUNCTION hpf_add_s2 (A, B)
  IMPLICIT NONE



  REAL(sp), INTENT(in) :: A(:,:), B(:,:)
  REAL(sp), DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_add_s2


  hpf_add_s2 = A + B
  RETURN
END FUNCTION hpf_add_s2
FUNCTION hpf_add_d1 (A, B)
  IMPLICIT NONE



  REAL(dp), INTENT(in) :: A(:), B(:)
  REAL(dp), DIMENSION(SIZE(A)) :: hpf_add_d1


  hpf_add_d1 = A + B
  RETURN
END FUNCTION hpf_add_d1
FUNCTION hpf_add_d2 (A, B)
  IMPLICIT NONE



  REAL(dp), INTENT(in) :: A(:,:), B(:,:)
  REAL(dp), DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_add_d2


  hpf_add_d2 = A + B
  RETURN
END FUNCTION hpf_add_d2
FUNCTION hpf_add_i1 (A, B)
  IMPLICIT NONE



  INTEGER, INTENT(in) :: A(:), B(:)
  INTEGER, DIMENSION(SIZE(A)) :: hpf_add_i1


  hpf_add_i1 = A + B
  RETURN
END FUNCTION hpf_add_i1
FUNCTION hpf_add_i2 (A, B)
  IMPLICIT NONE



  INTEGER, INTENT(in) :: A(:,:), B(:,:)
  INTEGER, DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_add_i2


  hpf_add_i2 = A + B
  RETURN
END FUNCTION hpf_add_i2
FUNCTION hpf_copy_s1 (A, B)
  IMPLICIT NONE



  REAL(sp), INTENT(in) :: A(:), B(:)
  REAL(sp), DIMENSION(SIZE(A)) :: hpf_copy_s1


  hpf_copy_s1 = B
  RETURN
END FUNCTION hpf_copy_s1
FUNCTION hpf_copy_s2 (A, B)
  IMPLICIT NONE



  REAL(sp), INTENT(in) :: A(:,:), B(:,:)
  REAL(sp), DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_copy_s2


  hpf_copy_s2 = B
  RETURN
END FUNCTION hpf_copy_s2
FUNCTION hpf_copy_d1 (A, B)
  IMPLICIT NONE



  REAL(dp), INTENT(in) :: A(:), B(:)
  REAL(dp), DIMENSION(SIZE(A)) :: hpf_copy_d1


  hpf_copy_d1 = B
  RETURN
END FUNCTION hpf_copy_d1
FUNCTION hpf_copy_d2 (A, B)
  IMPLICIT NONE



  REAL(dp), INTENT(in) :: A(:,:), B(:,:)
  REAL(dp), DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_copy_d2


  hpf_copy_d2 = B
  RETURN
END FUNCTION hpf_copy_d2
FUNCTION hpf_copy_i1 (A, B)
  IMPLICIT NONE



  INTEGER, INTENT(in) :: A(:), B(:)
  INTEGER, DIMENSION(SIZE(A)) :: hpf_copy_i1


  hpf_copy_i1 = B
  RETURN
END FUNCTION hpf_copy_i1
FUNCTION hpf_copy_i2 (A, B)
  IMPLICIT NONE



  INTEGER, INTENT(in) :: A(:,:), B(:,:)
  INTEGER, DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_copy_i2


  hpf_copy_i2 = B
  RETURN
END FUNCTION hpf_copy_i2
FUNCTION hpf_MAX_s1 (A, B)
  IMPLICIT NONE



  REAL(sp), INTENT(in) :: A(:), B(:)
  REAL(sp), DIMENSION(SIZE(A)) :: hpf_MAX_s1


  hpf_MAX_s1 = MAX(A,B)
  RETURN
END FUNCTION hpf_MAX_s1
FUNCTION hpf_MAX_s2 (A, B)
  IMPLICIT NONE



  REAL(sp), INTENT(in) :: A(:,:), B(:,:)
  REAL(sp), DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_MAX_s2


  hpf_MAX_s2 = MAX(A,B)
  RETURN
END FUNCTION hpf_MAX_s2
FUNCTION hpf_MAX_d1 (A, B)
  IMPLICIT NONE



  REAL(dp), INTENT(in) :: A(:), B(:)
  REAL(dp), DIMENSION(SIZE(A)) :: hpf_MAX_d1


  hpf_MAX_d1 = MAX(A,B)
  RETURN
END FUNCTION hpf_MAX_d1
FUNCTION hpf_MAX_d2 (A, B)
  IMPLICIT NONE



  REAL(dp), INTENT(in) :: A(:,:), B(:,:)
  REAL(dp), DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_MAX_d2


  hpf_MAX_d2 = MAX(A,B)
  RETURN
END FUNCTION hpf_MAX_d2
FUNCTION hpf_MAX_i1 (A, B)
  IMPLICIT NONE



  INTEGER, INTENT(in) :: A(:), B(:)
  INTEGER, DIMENSION(SIZE(A)) :: hpf_MAX_i1


  hpf_MAX_i1 = MAX(A,B)
  RETURN
END FUNCTION hpf_MAX_i1
FUNCTION hpf_MAX_i2 (A, B)
  IMPLICIT NONE



  INTEGER, INTENT(in) :: A(:,:), B(:,:)
  INTEGER, DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_MAX_i2


  hpf_MAX_i2 = MAX(A,B)
  RETURN
END FUNCTION hpf_MAX_i2
FUNCTION hpf_MIN_s1 (A, B)
  IMPLICIT NONE



  REAL(sp), INTENT(in) :: A(:), B(:)
  REAL(sp), DIMENSION(SIZE(A)) :: hpf_MIN_s1


  hpf_MIN_s1 = MIN(A,B)
  RETURN
END FUNCTION hpf_MIN_s1
FUNCTION hpf_MIN_s2 (A, B)
  IMPLICIT NONE



  REAL(sp), INTENT(in) :: A(:,:), B(:,:)
  REAL(sp), DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_MIN_s2


  hpf_MIN_s2 = MIN(A,B)
  RETURN
END FUNCTION hpf_MIN_s2
FUNCTION hpf_MIN_d1 (A, B)
  IMPLICIT NONE



  REAL(dp), INTENT(in) :: A(:), B(:)
  REAL(dp), DIMENSION(SIZE(A)) :: hpf_MIN_d1


  hpf_MIN_d1 = MIN(A,B)
  RETURN
END FUNCTION hpf_MIN_d1
FUNCTION hpf_MIN_d2 (A, B)
  IMPLICIT NONE



  REAL(dp), INTENT(in) :: A(:,:), B(:,:)
  REAL(dp), DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_MIN_d2


  hpf_MIN_d2 = MIN(A,B)
  RETURN
END FUNCTION hpf_MIN_d2
FUNCTION hpf_MIN_i1 (A, B)
  IMPLICIT NONE



  INTEGER, INTENT(in) :: A(:), B(:)
  INTEGER, DIMENSION(SIZE(A)) :: hpf_MIN_i1


  hpf_MIN_i1 = MIN(A,B)
  RETURN
END FUNCTION hpf_MIN_i1
FUNCTION hpf_MIN_i2 (A, B)
  IMPLICIT NONE



  INTEGER, INTENT(in) :: A(:,:), B(:,:)
  INTEGER, DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_MIN_i2


  hpf_MIN_i2 = MIN(A,B)
  RETURN
END FUNCTION hpf_MIN_i2
FUNCTION hpf_mult_s1 (A, B)
  IMPLICIT NONE



  REAL(sp), INTENT(in) :: A(:), B(:)
  REAL(sp), DIMENSION(SIZE(A)) :: hpf_mult_s1


  hpf_mult_s1 = A*B
  RETURN
END FUNCTION hpf_mult_s1
FUNCTION hpf_mult_s2 (A, B)
  IMPLICIT NONE



  REAL(sp), INTENT(in) :: A(:,:), B(:,:)
  REAL(sp), DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_mult_s2


  hpf_mult_s2 = A*B
  RETURN
END FUNCTION hpf_mult_s2
FUNCTION hpf_mult_d1 (A, B)
  IMPLICIT NONE



  REAL(dp), INTENT(in) :: A(:), B(:)
  REAL(dp), DIMENSION(SIZE(A)) :: hpf_mult_d1


  hpf_mult_d1 = A*B
  RETURN
END FUNCTION hpf_mult_d1
FUNCTION hpf_mult_d2 (A, B)
  IMPLICIT NONE



  REAL(dp), INTENT(in) :: A(:,:), B(:,:)
  REAL(dp), DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_mult_d2


  hpf_mult_d2 = A*B
  RETURN
END FUNCTION hpf_mult_d2
FUNCTION hpf_mult_i1 (A, B)
  IMPLICIT NONE



  INTEGER, INTENT(in) :: A(:), B(:)
  INTEGER, DIMENSION(SIZE(A)) :: hpf_mult_i1


  hpf_mult_i1 = A*B
  RETURN
END FUNCTION hpf_mult_i1
FUNCTION hpf_mult_i2 (A, B)
  IMPLICIT NONE



  INTEGER, INTENT(in) :: A(:,:), B(:,:)
  INTEGER, DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_mult_i2


  hpf_mult_i2 = A*B
  RETURN
END FUNCTION hpf_mult_i2
FUNCTION hpf_neqv_l1 (A, B)
  IMPLICIT NONE



  LOGICAL, INTENT(in) :: A(:), B(:)
  LOGICAL, DIMENSION(SIZE(A)) :: hpf_neqv_l1


  hpf_neqv_l1 = A .neqv. B
  RETURN
END FUNCTION hpf_neqv_l1
FUNCTION hpf_neqv_l2 (A, B)
  IMPLICIT NONE



  LOGICAL, INTENT(in) :: A(:,:), B(:,:)
  LOGICAL, DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_neqv_l2


  hpf_neqv_l2 = A .neqv. B
  RETURN
END FUNCTION hpf_neqv_l2
FUNCTION hpf_and_l1 (A, B)
  IMPLICIT NONE



  LOGICAL, INTENT(in) :: A(:), B(:)
  LOGICAL, DIMENSION(SIZE(A)) :: hpf_and_l1


  hpf_and_l1 = A .and. B
  RETURN
END FUNCTION hpf_and_l1
FUNCTION hpf_and_l2 (A, B)
  IMPLICIT NONE



  LOGICAL, INTENT(in) :: A(:,:), B(:,:)
  LOGICAL, DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_and_l2


  hpf_and_l2 = A .and. B
  RETURN
END FUNCTION hpf_and_l2
FUNCTION hpf_or_l1 (A, B)
  IMPLICIT NONE



  LOGICAL, INTENT(in) :: A(:), B(:)
  LOGICAL, DIMENSION(SIZE(A)) :: hpf_or_l1


  hpf_or_l1 = A .or. B
  RETURN
END FUNCTION hpf_or_l1
FUNCTION hpf_or_l2 (A, B)
  IMPLICIT NONE



  LOGICAL, INTENT(in) :: A(:,:), B(:,:)
  LOGICAL, DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_or_l2


  hpf_or_l2 = A .or. B
  RETURN
END FUNCTION hpf_or_l2
FUNCTION hpf_iand_i1 (A, B)
  IMPLICIT NONE



  INTEGER, INTENT(in) :: A(:), B(:)
  INTEGER, DIMENSION(SIZE(A)) :: hpf_iand_i1


  hpf_iand_i1 = iand(A,B)
  RETURN
END FUNCTION hpf_iand_i1
FUNCTION hpf_iand_i2 (A, B)
  IMPLICIT NONE



  INTEGER, INTENT(in) :: A(:,:), B(:,:)
  INTEGER, DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_iand_i2


  hpf_iand_i2 = iand(A,B)
  RETURN
END FUNCTION hpf_iand_i2
FUNCTION hpf_ieor_i1 (A, B)
  IMPLICIT NONE



  INTEGER, INTENT(in) :: A(:), B(:)
  INTEGER, DIMENSION(SIZE(A)) :: hpf_ieor_i1


  hpf_ieor_i1 = ieor(A,B)
  RETURN
END FUNCTION hpf_ieor_i1
FUNCTION hpf_ieor_i2 (A, B)
  IMPLICIT NONE



  INTEGER, INTENT(in) :: A(:,:), B(:,:)
  INTEGER, DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_ieor_i2


  hpf_ieor_i2 = ieor(A,B)
  RETURN
END FUNCTION hpf_ieor_i2
FUNCTION hpf_ior_i1 (A, B)
  IMPLICIT NONE



  INTEGER, INTENT(in) :: A(:), B(:)
  INTEGER, DIMENSION(SIZE(A)) :: hpf_ior_i1


  hpf_ior_i1 = ior(A,B)
  RETURN
END FUNCTION hpf_ior_i1
FUNCTION hpf_ior_i2 (A, B)
  IMPLICIT NONE



  INTEGER, INTENT(in) :: A(:,:), B(:,:)
  INTEGER, DIMENSION(SIZE(A,1),SIZE(A,2)) :: hpf_ior_i2


  hpf_ior_i2 = ior(A,B)
  RETURN
END FUNCTION hpf_ior_i2
END MODULE hpf_func
