MODULE HPF_SUFFIX_I

  USE Precision

CONTAINS
FUNCTION copy_suffix_i1 (array, segment)
  USE errorfun 
  USE hpf_func
  IMPLICIT NONE
  INTEGER, INTENT(in) :: array(:)
  LOGICAL, INTENT(in), OPTIONAL :: segment(:)
  INTEGER, DIMENSION(SIZE(array)) :: copy_suffix_i1
  copy_suffix_i1 = suffix_i1 (hpf_copy_i1, array, segment=segment)

  RETURN
END FUNCTION copy_suffix_i1
FUNCTION copy_suffix_i2 (array, dim, segment)
  ! ..Use Definitions..
  USE errorfun 
  USE hpf_func
  ! ..Implicit none ..
  IMPLICIT NONE
  ! ..Argument definitions..
  INTEGER, INTENT(in) :: array(:,:)
  INTEGER, INTENT(in), OPTIONAL :: dim
  LOGICAL, INTENT(in), OPTIONAL :: segment(:,:)
  INTEGER, DIMENSION(SIZE(array,1),SIZE(array,2)) :: copy_suffix_i2
  ! ..Local Variables..
  INTEGER :: n, n1, n2

  ! ..Executable Statements..
  IF (PRESENT(dim)) THEN
     copy_suffix_i2 = suffix_i2(hpf_copy_i2, array, dim, &
          segment = segment)
  ELSE IF (PRESENT(segment)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     copy_suffix_i2 = RESHAPE(suffix_i1(hpf_copy_i1, &
          array     = RESHAPE(array, (/n/)), &
          segment   = RESHAPE(segment,(/n/))), (/n1,n2/))
  ELSE
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     copy_suffix_i2 = RESHAPE(suffix_i1(hpf_copy_i1, &
          array     = RESHAPE(array, (/n/))), (/n1,n2/))
  END IF

  RETURN
END FUNCTION copy_suffix_i2
FUNCTION COUNT_suffix_l1 (mask, segment, exclusive)
  ! ..Use Definitions..
  USE errorfun
  USE hpf_func
  ! ..Implicit none ..
  IMPLICIT NONE
  ! ..Argument definitions..
  LOGICAL, INTENT(in) :: mask(:)
  LOGICAL, INTENT(in), OPTIONAL :: segment(:)
  LOGICAL, INTENT(in), OPTIONAL :: exclusive
  INTEGER, DIMENSION(SIZE(mask)) :: COUNT_suffix_l1
    ! ..Local Variables..
    INTEGER, DIMENSION(SIZE(mask)) :: Work

    WHERE (Mask)
       Work = 1
    ELSEWHERE
       Work = 0
    endwhere
    COUNT_suffix_l1 = suffix_i1 (hpf_add_i1, work, segment=segment, &
         exclusive=exclusive)

    999 RETURN
END FUNCTION COUNT_suffix_l1
FUNCTION COUNT_suffix_l2 (mask, dim, segment, exclusive)
  ! ..Use Definitions..
  USE errorfun
  USE hpf_func
  ! ..Implicit none ..
  IMPLICIT NONE
  ! ..Argument definitions..
  LOGICAL, INTENT(in) :: mask(:,:)
  INTEGER, INTENT(in), OPTIONAL :: dim
  LOGICAL, INTENT(in), OPTIONAL :: segment(:,:)
  LOGICAL, INTENT(in), OPTIONAL :: exclusive
  INTEGER, DIMENSION(SIZE(mask,1),SIZE(mask,2)) :: COUNT_suffix_l2
  ! ..Local Variables..
  INTEGER, DIMENSION(SIZE(mask,1),SIZE(mask,2)) :: Work
  INTEGER :: n, n1, n2

  ! ..Executable Statements..
  WHERE (Mask)
     Work = 1
  ELSEWHERE
     Work = 0
  endwhere
  IF (PRESENT(dim)) THEN
     COUNT_suffix_l2 = suffix_i2(hpf_add_i2, Work, dim, &
          segment   = segment, &
          exclusive = exclusive)
  ELSE IF (PRESENT(segment)) THEN
     n = SIZE(mask)
     n1 = SIZE(mask,1)
     n2 = SIZE(mask,2)
     COUNT_suffix_l2 = RESHAPE(suffix_i1(hpf_add_i1, &
          array      = RESHAPE(work, (/n/)), &
          segment   = RESHAPE(segment,(/n/)), &
          exclusive = exclusive), (/n1,n2/))
  ELSE 
     n = SIZE(mask)
     n1 = SIZE(mask,1)
     n2 = SIZE(mask,2)
     COUNT_suffix_l2 = RESHAPE(suffix_i1(hpf_add_i1, &
          array      = RESHAPE(work, (/n/)), &
          exclusive = exclusive), (/n1,n2/))
  END IF

  RETURN
END FUNCTION COUNT_suffix_l2
FUNCTION iall_suffix_i1 (array, mask, segment, exclusive)
  USE hpf_func
  IMPLICIT NONE
  INTEGER, INTENT(in) :: array(:)
  LOGICAL, INTENT(in), OPTIONAL :: mask(:), segment(:), exclusive
  INTEGER, DIMENSION(SIZE(array)) :: iall_suffix_i1
  iall_suffix_i1 = suffix_i1 (hpf_iand_i1, array, mask, segment, &
     exclusive, -1)

    RETURN
END FUNCTION iall_suffix_i1
FUNCTION iall_suffix_i2 (array, dim, mask, segment, exclusive)
  USE hpf_func
  IMPLICIT NONE
  INTEGER, INTENT(in) :: array(:,:)
  INTEGER, INTENT(in), OPTIONAL :: dim
  LOGICAL, INTENT(in), OPTIONAL :: mask(:,:), segment(:,:), exclusive
  INTEGER, DIMENSION(SIZE(array,1),SIZE(array,2)) :: iall_suffix_i2
  ! ..Local Variables..
  INTEGER :: n, n1, n2

  ! ..Executable Statements..
  IF (PRESENT(dim)) THEN
     iall_suffix_i2 = suffix_i2(hpf_iand_i2, array, dim, mask, &
          segment, exclusive, identity = -1)
  ELSE IF (PRESENT(mask) .and. PRESENT(segment)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     iall_suffix_i2 = RESHAPE(suffix_i1(hpf_iand_i1, &
          array     = RESHAPE(array, (/n/)), &
          mask      = RESHAPE(mask, (/n/)), &
          segment   = RESHAPE(segment,(/n/)), &
          exclusive = exclusive, &
          identity   = -1), (/n1,n2/))
  ELSE IF (PRESENT(mask)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     iall_suffix_i2 = RESHAPE(suffix_i1(hpf_iand_i1, &
          array     = RESHAPE(array, (/n/)), &
          mask      = RESHAPE(mask, (/n/)), &
          exclusive = exclusive, &
          identity   = -1), (/n1,n2/))
  ELSE IF (PRESENT(segment)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     iall_suffix_i2 = RESHAPE(suffix_i1(hpf_iand_i1, &
          array     = RESHAPE(array, (/n/)), &
          segment   = RESHAPE(segment,(/n/)), &
          exclusive = exclusive, &
          identity   = -1), (/n1,n2/))
  ELSE 
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     iall_suffix_i2 = RESHAPE(suffix_i1(hpf_iand_i1, &
          array     = RESHAPE(array, (/n/)), &
          exclusive = exclusive, &
          identity   = -1), (/n1,n2/))
  END IF

  RETURN
END FUNCTION iall_suffix_i2
FUNCTION iany_suffix_i1 (array, mask, segment, exclusive)
  USE hpf_func
  IMPLICIT NONE
  INTEGER, INTENT(in) :: array(:)
  LOGICAL, INTENT(in), OPTIONAL :: mask(:), segment(:), exclusive
  INTEGER, DIMENSION(SIZE(array)) :: iany_suffix_i1
  iany_suffix_i1 = suffix_i1 (hpf_ior_i1, array, mask, segment, &
     exclusive, 0)

    RETURN
END FUNCTION iany_suffix_i1
FUNCTION iany_suffix_i2 (array, dim, mask, segment, exclusive)
  USE hpf_func
  IMPLICIT NONE
  INTEGER, INTENT(in) :: array(:,:)
  INTEGER, INTENT(in), OPTIONAL :: dim
  LOGICAL, INTENT(in), OPTIONAL :: mask(:,:), segment(:,:), exclusive
  INTEGER, DIMENSION(SIZE(array,1),SIZE(array,2)) :: iany_suffix_i2
  ! ..Local Variables..
  INTEGER :: n, n1, n2

  ! ..Executable Statements..
  IF (PRESENT(dim)) THEN
     iany_suffix_i2 = suffix_i2(hpf_ior_i2, array, dim, mask, &
          segment, exclusive, identity = 0)
  ELSE IF (PRESENT(mask) .and. PRESENT(segment)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     iany_suffix_i2 = RESHAPE(suffix_i1(hpf_ior_i1, &
          array     = RESHAPE(array, (/n/)), &
          mask      = RESHAPE(mask, (/n/)), &
          segment   = RESHAPE(segment,(/n/)), &
          exclusive = exclusive, &
          identity   = 0), (/n1,n2/))
  ELSE IF (PRESENT(mask)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     iany_suffix_i2 = RESHAPE(suffix_i1(hpf_ior_i1, &
          array     = RESHAPE(array, (/n/)), &
          mask      = RESHAPE(mask, (/n/)), &
          exclusive = exclusive, &
          identity   = 0), (/n1,n2/))
  ELSE IF (PRESENT(segment)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     iany_suffix_i2 = RESHAPE(suffix_i1(hpf_ior_i1, &
          array     = RESHAPE(array, (/n/)), &
          segment   = RESHAPE(segment,(/n/)), &
          exclusive = exclusive, &
          identity   = 0), (/n1,n2/))
  ELSE 
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     iany_suffix_i2 = RESHAPE(suffix_i1(hpf_ior_i1, &
          array     = RESHAPE(array, (/n/)), &
          exclusive = exclusive, &
          identity   = 0), (/n1,n2/))
  END IF

  RETURN
END FUNCTION iany_suffix_i2
FUNCTION iparity_suffix_i1 (array, mask, segment, exclusive)
  USE hpf_func
  IMPLICIT NONE
  INTEGER, INTENT(in) :: array(:)
  LOGICAL, INTENT(in), OPTIONAL :: mask(:), segment(:), exclusive
  INTEGER, DIMENSION(SIZE(array)) :: iparity_suffix_i1
  iparity_suffix_i1 = suffix_i1 (hpf_ieor_i1, array, mask, segment, &
     exclusive, 0)

    RETURN
END FUNCTION iparity_suffix_i1
FUNCTION iparity_suffix_i2 (array, dim, mask, segment, exclusive)
  USE hpf_func
  IMPLICIT NONE
  INTEGER, INTENT(in) :: array(:,:)
  INTEGER, INTENT(in), OPTIONAL :: dim
  LOGICAL, INTENT(in), OPTIONAL :: mask(:,:), segment(:,:), exclusive
  INTEGER, DIMENSION(SIZE(array,1),SIZE(array,2)) :: iparity_suffix_i2
  ! ..Local Variables..
  INTEGER :: n, n1, n2

  ! ..Executable Statements..
  IF (PRESENT(dim)) THEN
     iparity_suffix_i2 = suffix_i2(hpf_ieor_i2, array, dim, mask, &
          segment, exclusive, identity = 0)
  ELSE IF (PRESENT(mask) .and. PRESENT(segment)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     iparity_suffix_i2 = RESHAPE(suffix_i1(hpf_ieor_i1, &
          array     = RESHAPE(array, (/n/)), &
          mask      = RESHAPE(mask, (/n/)), &
          segment   = RESHAPE(segment,(/n/)), &
          exclusive = exclusive, &
          identity   = 0), (/n1,n2/))
  ELSE IF (PRESENT(mask)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     iparity_suffix_i2 = RESHAPE(suffix_i1(hpf_ieor_i1, &
          array     = RESHAPE(array, (/n/)), &
          mask      = RESHAPE(mask, (/n/)), &
          exclusive = exclusive, &
          identity   = 0), (/n1,n2/))
  ELSE IF (PRESENT(segment)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     iparity_suffix_i2 = RESHAPE(suffix_i1(hpf_ieor_i1, &
          array     = RESHAPE(array, (/n/)), &
          segment   = RESHAPE(segment,(/n/)), &
          exclusive = exclusive, &
          identity   = 0), (/n1,n2/))
  ELSE 
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     iparity_suffix_i2 = RESHAPE(suffix_i1(hpf_ieor_i1, &
          array     = RESHAPE(array, (/n/)), &
          exclusive = exclusive, &
          identity   = 0), (/n1,n2/))
  END IF

  RETURN
END FUNCTION iparity_suffix_i2
  FUNCTION MAXVAL_suffix_i1 (array, mask, segment, exclusive)
    USE hpf_func
    IMPLICIT NONE
    INTEGER, INTENT(in) :: array(:)
    LOGICAL, INTENT(in), OPTIONAL :: mask(:), segment(:), exclusive
    INTEGER, DIMENSION(SIZE(array)) :: MAXVAL_suffix_i1
  ! ..Local Variables..
  INTEGER :: identity



  identity = MINVAL(array)


  MAXVAL_suffix_i1 = suffix_i1 (hpf_MAX_i1, array, mask, segment, &
     exclusive, identity)

  RETURN
END FUNCTION MAXVAL_suffix_i1
  FUNCTION MAXVAL_suffix_i2 (array, dim, mask, segment, exclusive)
    USE hpf_func
    IMPLICIT NONE
    INTEGER, INTENT(in) :: array(:,:)
    INTEGER, INTENT(in), OPTIONAL :: dim
    LOGICAL, INTENT(in), OPTIONAL :: mask(:,:), segment(:,:), exclusive
    INTEGER, DIMENSION(SIZE(array,1),SIZE(array,2)) :: MAXVAL_suffix_i2
  ! ..Local Variables..
  INTEGER :: identity
  INTEGER :: n, n1, n2



  identity = MINVAL(array)



  ! ..Executable Statements..
  IF (PRESENT(dim)) THEN
     MAXVAL_suffix_i2 = suffix_i2(hpf_MAX_i2, array, dim, mask, &
          segment, exclusive, identity = identity)
  ELSE IF (PRESENT(mask) .and. PRESENT(segment)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     MAXVAL_suffix_i2 = RESHAPE(suffix_i1(hpf_MAX_i1, &
          array     = RESHAPE(array, (/n/)), &
          mask      = RESHAPE(mask, (/n/)), &
          segment   = RESHAPE(segment,(/n/)), &
          exclusive = exclusive, &
          identity   = identity), (/n1,n2/))
  ELSE IF (PRESENT(mask)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     MAXVAL_suffix_i2 = RESHAPE(suffix_i1(hpf_MAX_i1, &
          array     = RESHAPE(array, (/n/)), &
          mask      = RESHAPE(mask, (/n/)), &
          exclusive = exclusive, &
          identity   = identity), (/n1,n2/))
  ELSE IF (PRESENT(segment)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     MAXVAL_suffix_i2 = RESHAPE(suffix_i1(hpf_MAX_i1, &
          array     = RESHAPE(array, (/n/)), &
          segment   = RESHAPE(segment,(/n/)), &
          exclusive = exclusive, &
          identity   = identity), (/n1,n2/))
  ELSE 
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     MAXVAL_suffix_i2 = RESHAPE(suffix_i1(hpf_MAX_i1, &
          array     = RESHAPE(array, (/n/)), &
          exclusive = exclusive, &
          identity   = identity), (/n1,n2/))
  END IF

  RETURN
END FUNCTION MAXVAL_suffix_i2
FUNCTION MINVAL_suffix_i1 (array, mask, segment, exclusive)
  USE hpf_func
  IMPLICIT NONE
  INTEGER, INTENT(in) :: array(:)
  LOGICAL, INTENT(in), OPTIONAL :: mask(:), segment(:), exclusive
  INTEGER, DIMENSION(SIZE(array)) :: MINVAL_suffix_i1
  ! ..Local Variables..
  INTEGER :: identity



  identity = MAXVAL(array)


  MINVAL_suffix_i1 = suffix_i1 (hpf_MIN_i1, array, mask, segment, &
     exclusive, identity)

  RETURN
END FUNCTION MINVAL_suffix_i1
FUNCTION MINVAL_suffix_i2 (array, dim, mask, segment, exclusive)
  USE hpf_func
  IMPLICIT NONE
  INTEGER, INTENT(in) :: array(:,:)
  INTEGER, INTENT(in), OPTIONAL :: dim
  LOGICAL, INTENT(in), OPTIONAL :: mask(:,:), segment(:,:), exclusive
  INTEGER, DIMENSION(SIZE(array,1),SIZE(array,2)) :: MINVAL_suffix_i2
  ! ..Local Variables..
  INTEGER :: identity
  INTEGER :: n, n1, n2



  identity = MAXVAL(array)



  ! ..Executable Statements..
  IF (PRESENT(dim)) THEN
     MINVAL_suffix_i2 = suffix_i2(hpf_MIN_i2, array, dim, mask, &
          segment, exclusive, identity = identity)
  ELSE IF (PRESENT(mask) .and. PRESENT(segment)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     MINVAL_suffix_i2 = RESHAPE(suffix_i1(hpf_MIN_i1, &
          array     = RESHAPE(array, (/n/)), &
          mask      = RESHAPE(mask, (/n/)), &
          segment   = RESHAPE(segment,(/n/)), &
          exclusive = exclusive, &
          identity   = identity), (/n1,n2/))
  ELSE IF (PRESENT(mask)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     MINVAL_suffix_i2 = RESHAPE(suffix_i1(hpf_MIN_i1, &
          array     = RESHAPE(array, (/n/)), &
          mask      = RESHAPE(mask, (/n/)), &
          exclusive = exclusive, &
          identity   = identity), (/n1,n2/))
  ELSE IF (PRESENT(segment)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     MINVAL_suffix_i2 = RESHAPE(suffix_i1(hpf_MIN_i1, &
          array     = RESHAPE(array, (/n/)), &
          segment   = RESHAPE(segment,(/n/)), &
          exclusive = exclusive, &
          identity   = identity), (/n1,n2/))
  ELSE 
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     MINVAL_suffix_i2 = RESHAPE(suffix_i1(hpf_MIN_i1, &
          array     = RESHAPE(array, (/n/)), &
          exclusive = exclusive, &
          identity   = identity), (/n1,n2/))
  END IF

  RETURN
END FUNCTION MINVAL_suffix_i2
FUNCTION product_suffix_i1 (array, mask, segment, exclusive)
  USE hpf_func
  IMPLICIT NONE
  INTEGER, INTENT(in) :: array(:)
  LOGICAL, INTENT(in), OPTIONAL :: mask(:), segment(:), exclusive
  INTEGER, DIMENSION(SIZE(array)) :: product_suffix_i1
  product_suffix_i1 = suffix_i1 (hpf_mult_i1, array, mask, segment, &
     exclusive, 1)

    RETURN
END FUNCTION product_suffix_i1
FUNCTION product_suffix_i2 (array, dim, mask, segment, exclusive)
  USE hpf_func
  IMPLICIT NONE
  INTEGER, INTENT(in) :: array(:,:)
  INTEGER, INTENT(in), OPTIONAL :: dim
  LOGICAL, INTENT(in), OPTIONAL :: mask(:,:), segment(:,:), exclusive
  INTEGER, DIMENSION(SIZE(array,1),SIZE(array,2)) :: product_suffix_i2
  ! ..Local Variables..
  INTEGER :: n, n1, n2

  ! ..Executable Statements..
  IF (PRESENT(dim)) THEN
     product_suffix_i2 = suffix_i2(hpf_mult_i2, array, dim, mask, &
          segment, exclusive, identity = 1)
  ELSE IF (PRESENT(mask) .and. PRESENT(segment)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     product_suffix_i2 = RESHAPE(suffix_i1(hpf_mult_i1, &
          array     = RESHAPE(array, (/n/)), &
          mask      = RESHAPE(mask, (/n/)), &
          segment   = RESHAPE(segment,(/n/)), &
          exclusive = exclusive, &
          identity   = 1), (/n1,n2/))
  ELSE IF (PRESENT(mask)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     product_suffix_i2 = RESHAPE(suffix_i1(hpf_mult_i1, &
          array     = RESHAPE(array, (/n/)), &
          mask      = RESHAPE(mask, (/n/)), &
          exclusive = exclusive, &
          identity   = 1), (/n1,n2/))
  ELSE IF (PRESENT(segment)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     product_suffix_i2 = RESHAPE(suffix_i1(hpf_mult_i1, &
          array     = RESHAPE(array, (/n/)), &
          segment   = RESHAPE(segment,(/n/)), &
          exclusive = exclusive, &
          identity   = 1), (/n1,n2/))
  ELSE 
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     product_suffix_i2 = RESHAPE(suffix_i1(hpf_mult_i1, &
          array     = RESHAPE(array, (/n/)), &
          exclusive = exclusive, &
          identity   = 1), (/n1,n2/))
  END IF

  RETURN
END FUNCTION product_suffix_i2
FUNCTION sum_suffix_i1 (array, mask, segment, exclusive)
  USE hpf_func
  IMPLICIT NONE
  INTEGER, INTENT(in) :: array(:)
  LOGICAL, INTENT(in), OPTIONAL :: mask(:), segment(:), exclusive
  INTEGER, DIMENSION(SIZE(array)) :: sum_suffix_i1
    ! Call generic suffix routine
    sum_suffix_i1 = suffix_i1 (hpf_add_i1, array, mask, segment, exclusive)

    RETURN
  END FUNCTION sum_suffix_i1
FUNCTION sum_suffix_i2 (array, dim, mask, segment, exclusive)
  USE hpf_func
  IMPLICIT NONE
  INTEGER, INTENT(in) :: array(:,:)
  INTEGER, INTENT(in), OPTIONAL :: dim
  LOGICAL, INTENT(in), OPTIONAL :: mask(:,:), segment(:,:), exclusive
  INTEGER, DIMENSION(SIZE(array,1),SIZE(array,2)) :: sum_suffix_i2
  ! ..Local Variables..
  INTEGER :: n, n1, n2

  ! ..Executable Statements..
  IF (PRESENT(dim)) THEN
     sum_suffix_i2 = suffix_i2(hpf_add_i2, array, dim, mask, &
          segment, exclusive, identity = 0)
  ELSE IF (PRESENT(mask) .and. PRESENT(segment)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     sum_suffix_i2 = RESHAPE(suffix_i1(hpf_add_i1, &
          array     = RESHAPE(array, (/n/)), &
          mask      = RESHAPE(mask, (/n/)), &
          segment   = RESHAPE(segment,(/n/)), &
          exclusive = exclusive, &
          identity   = 0), (/n1,n2/))
  ELSE IF (PRESENT(mask)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     sum_suffix_i2 = RESHAPE(suffix_i1(hpf_add_i1, &
          array     = RESHAPE(array, (/n/)), &
          mask      = RESHAPE(mask, (/n/)), &
          exclusive = exclusive, &
          identity   = 0), (/n1,n2/))
  ELSE IF (PRESENT(segment)) THEN
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     sum_suffix_i2 = RESHAPE(suffix_i1(hpf_add_i1, &
          array     = RESHAPE(array, (/n/)), &
          segment   = RESHAPE(segment,(/n/)), &
          exclusive = exclusive, &
          identity   = 0), (/n1,n2/))
  ELSE 
     n = SIZE(array)
     n1 = SIZE(array,1)
     n2 = SIZE(array,2)
     sum_suffix_i2 = RESHAPE(suffix_i1(hpf_add_i1, &
          array     = RESHAPE(array, (/n/)), &
          exclusive = exclusive, &
          identity   = 0), (/n1,n2/))
  END IF

  RETURN
END FUNCTION sum_suffix_i2
FUNCTION suffix_i1 (func, array, mask, segment, exclusive, identity)
  ! ..Use definitions..
  USE errorfun 
  IMPLICIT NONE
  ! ..Arguments..
  ! ..Interface definition ..
  INTERFACE 
    FUNCTION func (A, B)
      USE precision
      INTEGER, INTENT(in) ::  A(:), B(:)
      INTEGER, DIMENSION(SIZE(A)) :: func
    END FUNCTION func
  END INTERFACE
  INTEGER, INTENT(in) :: array(:)
  LOGICAL, INTENT(in), OPTIONAL :: mask(:), segment(:), exclusive
  INTEGER, INTENT(in), OPTIONAL :: identity
  INTEGER, DIMENSION(SIZE(array)) :: suffix_i1
  ! .. Local Parameters ..
  CHARACTER(LEN=*), PARAMETER :: SRName = 'SUFFIX'
  ! .. Local Variables ..
  INTEGER, DIMENSION(SIZE(array)) :: work
  REAL :: identity_element
  LOGICAL, DIMENSION(SIZE(array)) :: sm
  INTEGER :: istep, n

  ! Test for constraints on parameters
  n = SIZE(array)
  IF (n == 0) THEN
     CALL error (100, SRName, &
          'ARRAY argument has size zero.')
     suffix_i1 = 0
     GOTO 999
  END IF
  IF (PRESENT(mask)) THEN
     IF (SIZE(mask) /= n) THEN
        CALL error (302, SRName, &
             'Argument MASK does not have the same size as ARRAY.')
        GOTO 999
     END IF
  END IF
  IF (PRESENT(segment)) THEN
     IF (SIZE(segment) /= n) THEN
        CALL error (303, SRName, &
             'Argument SEGMENT does not have the same size as ARRAY.')
        GOTO 999
     END IF
  END IF
  IF (PRESENT(identity)) THEN
     identity_element = identity
  ELSE
     identity_element = 0.0
  END IF

  ! Is there a MASK or not?
  IF (PRESENT(mask)) THEN
     WHERE (mask)
        work = array
     ELSEWHERE
        work = identity_element
     END WHERE
  ELSE      
     work = array
  END IF

  ! Compute the segment mask
  IF (PRESENT(segment)) THEN
     sm = .not. (eoshift(segment,1) .neqv. segment)
     sm(n) = .false.
     istep = 1
     DO
        IF (.not. ANY(sm)) EXIT
        ! if (istep >= n) exit ! This may be faster on some machines
        WHERE (sm(1:n-istep))
           work(1:n-istep) = func(work(1:n-istep),work(istep+1:n))
        END WHERE
        sm(1:n-istep) =  sm(1:n-istep) .and. sm(istep+1:n)
        istep = istep*2
     END DO
  ELSE
     istep = 1
     DO
        IF (istep >= n) EXIT
        work(1:n-istep) = func(work(1:n-istep),work(istep+1:n))
        istep = istep*2
     END DO
  END IF

  ! Exclusive?
  IF (PRESENT(exclusive)) THEN
     IF (exclusive) THEN
        IF (PRESENT(segment)) THEN
           sm = (eoshift(segment,1) .neqv. segment)
           sm(n) = .true.
           work = eoshift(work,1)
           WHERE (sm)
              work = 0.0
           END WHERE
        ELSE
           work = eoshift(work,1)
        END IF
     END IF
  END IF

  suffix_i1 = work

  999 RETURN
END FUNCTION suffix_i1
FUNCTION suffix_i2 (func, array, dim, mask, segment, exclusive, identity)
  ! ..Use definitions..
  USE errorfun
  IMPLICIT NONE
  ! ..Arguments..
  ! ..Interface definition ..
  INTERFACE 
    FUNCTION func (A, B)
      INTEGER, INTENT(in) ::  A(:,:), B(:,:)
      INTEGER, DIMENSION(SIZE(A,1),SIZE(A,2)) :: func
    END FUNCTION func
  END INTERFACE
  INTEGER, INTENT(in) :: array(:,:)
  INTEGER, INTENT(in) :: dim
  LOGICAL, INTENT(in), OPTIONAL :: mask(:,:), segment(:,:), exclusive
  INTEGER, INTENT(in), OPTIONAL :: identity
  INTEGER, DIMENSION(SIZE(array,1),SIZE(array,2)) :: suffix_i2
  ! .. Local Parameters ..
  CHARACTER(LEN=*), PARAMETER :: SRName = 'SUFFIX'
  ! .. Local Variables ..
  INTEGER, DIMENSION(SIZE(array,1),SIZE(array,2)) :: work
  LOGICAL, DIMENSION(SIZE(array,1),SIZE(array,2)) :: sm
  INTEGER :: identity_element
  INTEGER :: istep, n1, n2

  ! Test for constraints on parameters
  n1 = SIZE(array,1)
  n2 = SIZE(array,2)
  IF (SIZE(array) == 0) THEN
     CALL error (100, SRName, &
          'ARRAY argument has size zero.')
     suffix_i2 = 0
     GOTO 999
  END IF
  IF (dim>2) THEN
     CALL error (300, SRName, &
          'Argument DIM  is bigger than dimension of ARRAY.')
     GOTO 999
  END IF
  IF (dim<=0) THEN
     CALL error (301, SRName, &
          'Argument DIM must be bigger or equal to 1.')
     GOTO 999
  END IF
  IF (PRESENT(mask)) THEN
     IF (SIZE(mask,1) /= SIZE(array,1) .or. &
          SIZE(mask,2) /= SIZE(array,2)) THEN
        CALL error (302, SRName, &
             'Argument MASK does not have the same size as ARRAY.')
        GOTO 999
     END IF
  END IF
  IF (PRESENT(segment)) THEN
     IF (SIZE(segment,1) /= SIZE(array,1) .or. &
          SIZE(segment,2) /= SIZE(array,2)) THEN
        CALL error (303, SRName, &
             'Argument SEGMENT does not have the same size as ARRAY.')
        GOTO 999
     END IF
  END IF
  IF (PRESENT(identity)) THEN
     identity_element = identity
  ELSE
     identity_element = 0.0
  END IF

  ! Is there a MASK or not?
  IF (PRESENT(mask)) THEN
     WHERE (mask)
        work = array
     ELSEWHERE
        work = identity_element
     END WHERE
  ELSE      
     work = array
  END IF

  ! Compute the segment mask
  IF (PRESENT(segment)) THEN
     IF (dim==1) THEN
        sm = .not. (eoshift(segment,1,dim=dim) .neqv. segment)
        sm (n1,:) = .false.
        istep = 1
        DO
           IF (.not. ANY(sm)) EXIT
           ! if (istep >= n) exit ! This may be faster on some machines
           WHERE (sm(1:n1-istep,:))
              work(1:n1-istep,:) = &
                   func(work(1:n1-istep,:),work(istep+1:n1,:))
           END WHERE
           sm(1:n1-istep,:) =  sm(1:n1-istep,:) .and. sm(istep+1:n1,:)
           istep = istep*2
        END DO
     ELSE
        sm = .not. (eoshift(segment,1,dim=dim) .neqv. segment)
        sm(:,n2) = .false.
        istep = 1
        DO
           IF (.not. ANY(sm)) EXIT
           ! if (istep >= n) exit ! This may be faster on some machines
           WHERE (sm(:,1:n2-istep))
              work(:,1:n2-istep) = &
                   func(work(:,1:n2-istep),work(:,istep+1:n2))
           END WHERE
           sm(:,1:n2-istep) =  sm(:,1:n2-istep) .and. sm(:,istep+1:n2)
           istep = istep*2
        END DO
     END IF
  ELSE
     IF (dim==1) THEN
        istep = 1
        DO
           IF (istep>=n1) EXIT
           work(1:n1-istep,:) = &
                func(work(1:n1-istep,:),work(istep+1:n1,:))
           istep = istep*2
        END DO
     ELSE                       ! dim=2
        istep = 1
        DO 
           IF (istep>=n2) EXIT
           work(:,1:n2-istep) = &
                func(work(:,1:n2-istep),work(:,istep+1:n2))
           istep = istep*2
        END DO
     END IF
  END IF

  ! Exclusive?
  IF (PRESENT(exclusive)) THEN
     IF (exclusive) THEN
        IF (PRESENT(segment)) THEN
           sm = (eoshift(segment,1,dim=dim) .neqv. segment)
           work = eoshift(work,1,dim=dim)
           WHERE (sm)
              work = 0.0
           END WHERE
        ELSE
           work = eoshift(work,-1,dim=dim)
        END IF
     END IF
  END IF

  suffix_i2 = work

  999 RETURN
END FUNCTION suffix_i2
END MODULE HPF_SUFFIX_I
