MODULE HPF_Scatter
  USE hpf_func
  USE precision
  USE HPF_SCATTER_I
  USE HPF_SCATTER_S
  USE HPF_SCATTER_D
  USE HPF_SCATTER_L

  INTERFACE ALL_SCATTER
     MODULE PROCEDURE  ALL_SCATTER_l1_i1
     MODULE PROCEDURE  ALL_SCATTER_l1_i2
     MODULE PROCEDURE  ALL_SCATTER_l2_i1
     MODULE PROCEDURE  ALL_SCATTER_l2_i2
  END INTERFACE

  INTERFACE ANY_SCATTER
     MODULE PROCEDURE  ANY_SCATTER_l1_i1
     MODULE PROCEDURE  ANY_SCATTER_l1_i2
     MODULE PROCEDURE  ANY_SCATTER_l2_i1
     MODULE PROCEDURE  ANY_SCATTER_l2_i2
  END INTERFACE 

  INTERFACE COPY_SCATTER
     MODULE PROCEDURE  COPY_SCATTER_i1_i1
     MODULE PROCEDURE  COPY_SCATTER_i1_i2
     MODULE PROCEDURE  COPY_SCATTER_i2_i1
     MODULE PROCEDURE  COPY_SCATTER_i2_i2
     MODULE PROCEDURE  COPY_SCATTER_s1_s1
     MODULE PROCEDURE  COPY_SCATTER_s1_s2
     MODULE PROCEDURE  COPY_SCATTER_s2_s1
     MODULE PROCEDURE  COPY_SCATTER_s2_s2
     MODULE PROCEDURE  COPY_SCATTER_d1_d1
     MODULE PROCEDURE  COPY_SCATTER_d1_d2
     MODULE PROCEDURE  COPY_SCATTER_d2_d1
     MODULE PROCEDURE  COPY_SCATTER_d2_d2
  END INTERFACE 

  INTERFACE COUNT_SCATTER
     MODULE PROCEDURE  COUNT_SCATTER_i1_i1
     MODULE PROCEDURE  COUNT_SCATTER_i1_i2
     MODULE PROCEDURE  COUNT_SCATTER_i2_i1
     MODULE PROCEDURE  COUNT_SCATTER_i2_i2
  END INTERFACE 

  INTERFACE IALL_SCATTER
     MODULE PROCEDURE  IALL_SCATTER_i1_i1
     MODULE PROCEDURE  IALL_SCATTER_i1_i2
     MODULE PROCEDURE  IALL_SCATTER_i2_i1
     MODULE PROCEDURE  IALL_SCATTER_i2_i2
  END INTERFACE 

  INTERFACE IANY_SCATTER
     MODULE PROCEDURE  IANY_SCATTER_i1_i1
     MODULE PROCEDURE  IANY_SCATTER_i1_i2
     MODULE PROCEDURE  IANY_SCATTER_i2_i1
     MODULE PROCEDURE  IANY_SCATTER_i2_i2
  END INTERFACE 

  INTERFACE IPARITY_SCATTER
     MODULE PROCEDURE  IPARITY_SCATTER_i1_i1
     MODULE PROCEDURE  IPARITY_SCATTER_i1_i2
     MODULE PROCEDURE  IPARITY_SCATTER_i2_i1
     MODULE PROCEDURE  IPARITY_SCATTER_i2_i2
  END INTERFACE 

  INTERFACE MAXVAL_SCATTER
     MODULE PROCEDURE  MAXVAL_SCATTER_d1_d1
     MODULE PROCEDURE  MAXVAL_SCATTER_d1_d2
     MODULE PROCEDURE  MAXVAL_SCATTER_d2_d1
     MODULE PROCEDURE  MAXVAL_SCATTER_d2_d2
     MODULE PROCEDURE  MAXVAL_SCATTER_i1_i1
     MODULE PROCEDURE  MAXVAL_SCATTER_i1_i2
     MODULE PROCEDURE  MAXVAL_SCATTER_i2_i1
     MODULE PROCEDURE  MAXVAL_SCATTER_i2_i2
     MODULE PROCEDURE  MAXVAL_SCATTER_s1_s1
     MODULE PROCEDURE  MAXVAL_SCATTER_s1_s2
     MODULE PROCEDURE  MAXVAL_SCATTER_s2_s1
     MODULE PROCEDURE  MAXVAL_SCATTER_s2_s2
  END INTERFACE 

  INTERFACE MINVAL_SCATTER
     MODULE PROCEDURE  MINVAL_SCATTER_d1_d1
     MODULE PROCEDURE  MINVAL_SCATTER_d1_d2
     MODULE PROCEDURE  MINVAL_SCATTER_d2_d1
     MODULE PROCEDURE  MINVAL_SCATTER_d2_d2
     MODULE PROCEDURE  MINVAL_SCATTER_i1_i1
     MODULE PROCEDURE  MINVAL_SCATTER_i1_i2
     MODULE PROCEDURE  MINVAL_SCATTER_i2_i1
     MODULE PROCEDURE  MINVAL_SCATTER_i2_i2
     MODULE PROCEDURE  MINVAL_SCATTER_s1_s1
     MODULE PROCEDURE  MINVAL_SCATTER_s1_s2
     MODULE PROCEDURE  MINVAL_SCATTER_s2_s1
     MODULE PROCEDURE  MINVAL_SCATTER_s2_s2
  END INTERFACE 

  INTERFACE PRODUCT_SCATTER
     MODULE PROCEDURE  PRODUCT_SCATTER_d1_d1
     MODULE PROCEDURE  PRODUCT_SCATTER_d1_d2
     MODULE PROCEDURE  PRODUCT_SCATTER_d2_d1
     MODULE PROCEDURE  PRODUCT_SCATTER_d2_d2
     MODULE PROCEDURE  PRODUCT_SCATTER_i1_i1
     MODULE PROCEDURE  PRODUCT_SCATTER_i1_i2
     MODULE PROCEDURE  PRODUCT_SCATTER_i2_i1
     MODULE PROCEDURE  PRODUCT_SCATTER_i2_i2
     MODULE PROCEDURE  PRODUCT_SCATTER_s1_s1
     MODULE PROCEDURE  PRODUCT_SCATTER_s1_s2
     MODULE PROCEDURE  PRODUCT_SCATTER_s2_s1
     MODULE PROCEDURE  PRODUCT_SCATTER_s2_s2
  END INTERFACE 

  INTERFACE SUM_SCATTER
     MODULE PROCEDURE  SUM_SCATTER_d1_d1
     MODULE PROCEDURE  SUM_SCATTER_d1_d2
     MODULE PROCEDURE  SUM_SCATTER_d2_d1
     MODULE PROCEDURE  SUM_SCATTER_d2_d2
     MODULE PROCEDURE  SUM_SCATTER_i1_i1
     MODULE PROCEDURE  SUM_SCATTER_i1_i2
     MODULE PROCEDURE  SUM_SCATTER_i2_i1
     MODULE PROCEDURE  SUM_SCATTER_i2_i2
     MODULE PROCEDURE  SUM_SCATTER_s1_s1
     MODULE PROCEDURE  SUM_SCATTER_s1_s2
     MODULE PROCEDURE  SUM_SCATTER_s2_s1
     MODULE PROCEDURE  SUM_SCATTER_s2_s2
  END INTERFACE 

CONTAINS 
FUNCTION SUM_SCATTER_i1_i1(array,base,indx1,mask)
  INTEGER, intent(in)                         :: array(:)
  INTEGER, intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER, dimension(lbound(base,dim=1):ubound(base,dim=1))::SUM_SCATTER_i1_i1

  SUM_SCATTER_i1_i1=ScatterWith_i1_i1(hpf_add_i1,0,array,base,indx1,mask)
END FUNCTION SUM_SCATTER_i1_i1
FUNCTION SUM_SCATTER_s1_s1(array,base,indx1,mask)
  REAL(kind=sp), intent(in)                   :: array(:)
  REAL(kind=sp), intent(in)                   :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  LOGICAL, intent(in), optional               :: mask(:)

  REAL(kind=sp), dimension(lbound(base,dim=1): &
                           ubound(base,dim=1))::SUM_SCATTER_s1_s1

  SUM_SCATTER_s1_s1=ScatterWith_s1_s1(hpf_add_s1,0.0_sp,array,base,indx1,mask)
END FUNCTION SUM_SCATTER_s1_s1
FUNCTION SUM_SCATTER_d1_d1(array,base,indx1,mask)
  REAL(kind=dp), intent(in)                   :: array(:)
  REAL(kind=dp), intent(in)                   :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  LOGICAL, intent(in), optional               :: mask(:)

  REAL(kind=dp), dimension(lbound(base,dim=1): &
                           ubound(base,dim=1))::SUM_SCATTER_d1_d1

  SUM_SCATTER_d1_d1=ScatterWith_d1_d1(hpf_add_d1,0.0_dp,array,base,indx1,mask)
END FUNCTION SUM_SCATTER_d1_d1
FUNCTION PRODUCT_SCATTER_i1_i1(array,base,indx1,mask)
  INTEGER, intent(in)                         :: array(:)
  INTEGER, intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::PRODUCT_SCATTER_i1_i1

  PRODUCT_SCATTER_i1_i1=ScatterWith_i1_i1(hpf_mult_i1,1,array,base,indx1,mask)
END FUNCTION PRODUCT_SCATTER_i1_i1
FUNCTION PRODUCT_SCATTER_s1_s1(array,base,indx1,mask)
  REAL(kind=sp), intent(in)                   :: array(:)
  REAL(kind=sp), intent(in)                   :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  LOGICAL, intent(in), optional               :: mask(:)

  REAL(kind=sp), dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::PRODUCT_SCATTER_s1_s1

  PRODUCT_SCATTER_s1_s1=ScatterWith_s1_s1(hpf_mult_s1,1.0_sp,array,base,indx1,mask)
END FUNCTION PRODUCT_SCATTER_s1_s1
FUNCTION PRODUCT_SCATTER_d1_d1(array,base,indx1,mask)
  REAL(kind=dp), intent(in)                   :: array(:)
  REAL(kind=dp), intent(in)                   :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  LOGICAL, intent(in), optional               :: mask(:)

  REAL(kind=dp), dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::PRODUCT_SCATTER_d1_d1

  PRODUCT_SCATTER_d1_d1=ScatterWith_d1_d1(hpf_mult_d1,1.0_dp,array,base,indx1,mask)
END FUNCTION PRODUCT_SCATTER_d1_d1
FUNCTION COUNT_SCATTER_i1_i1(mask,base,indx1)
  LOGICAL, intent(in)                         :: mask(:)
  INTEGER, intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(mask))  :: indx1(:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::COUNT_SCATTER_i1_i1

  INTEGER i

  COUNT_SCATTER_i1_i1=ScatterWith_i1_i1(hpf_add_i1,0, &
                          (/(1,i=1,size(mask))/),base,indx1,mask)
END FUNCTION COUNT_SCATTER_i1_i1
FUNCTION MAXVAL_SCATTER_i1_i1(array,base,indx1,mask)
  INTEGER, intent(in)                         :: array(:)
  INTEGER, intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::MAXVAL_SCATTER_i1_i1

  MAXVAL_SCATTER_i1_i1=ScatterWith_i1_i1(hpf_MAX_i1,MINVAL(array), &
                                         array,base,indx1,mask)
END FUNCTION MAXVAL_SCATTER_i1_i1
FUNCTION MAXVAL_SCATTER_s1_s1(array,base,indx1,mask)
  REAL(kind=sp), intent(in)                         :: array(:)
  REAL(kind=sp), intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  LOGICAL, intent(in), optional               :: mask(:)

  REAL(kind=sp), dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::MAXVAL_SCATTER_s1_s1

  MAXVAL_SCATTER_s1_s1=ScatterWith_s1_s1(hpf_MAX_s1,MINVAL(array), &
                                         array,base,indx1,mask)
END FUNCTION MAXVAL_SCATTER_s1_s1
FUNCTION MAXVAL_SCATTER_d1_d1(array,base,indx1,mask)
  REAL(kind=dp), intent(in)                         :: array(:)
  REAL(kind=dp), intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  LOGICAL, intent(in), optional               :: mask(:)

  REAL(kind=dp), dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::MAXVAL_SCATTER_d1_d1

  MAXVAL_SCATTER_d1_d1=ScatterWith_d1_d1(hpf_MAX_d1,MINVAL(array), &
                                         array,base,indx1,mask)
END FUNCTION MAXVAL_SCATTER_d1_d1
FUNCTION MINVAL_SCATTER_i1_i1(array,base,indx1,mask)
  INTEGER, intent(in)                         :: array(:)
  INTEGER, intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::MINVAL_SCATTER_i1_i1

  MINVAL_SCATTER_i1_i1=ScatterWith_i1_i1(hpf_MIN_i1,MAXVAL(array), &
                                         array,base,indx1,mask)
END FUNCTION MINVAL_SCATTER_i1_i1
FUNCTION MINVAL_SCATTER_s1_s1(array,base,indx1,mask)
  REAL(kind=sp), intent(in)                   :: array(:)
  REAL(kind=sp), intent(in)                   :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  LOGICAL, intent(in), optional               :: mask(:)

  REAL(kind=sp), dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::MINVAL_SCATTER_s1_s1

  MINVAL_SCATTER_s1_s1=ScatterWith_s1_s1(hpf_MIN_s1,MAXVAL(array), &
                                         array,base,indx1,mask)
END FUNCTION MINVAL_SCATTER_s1_s1
FUNCTION MINVAL_SCATTER_d1_d1(array,base,indx1,mask)
  REAL(kind=dp), intent(in)                   :: array(:)
  REAL(kind=dp), intent(in)                   :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  LOGICAL, intent(in), optional               :: mask(:)

  REAL(kind=dp), dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::MINVAL_SCATTER_d1_d1

  MINVAL_SCATTER_d1_d1=ScatterWith_d1_d1(hpf_MIN_d1,MAXVAL(array), &
                                         array,base,indx1,mask)
END FUNCTION MINVAL_SCATTER_d1_d1
FUNCTION IALL_SCATTER_i1_i1(array,base,indx1,mask)
  INTEGER, intent(in)                         :: array(:)
  INTEGER, intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::IALL_SCATTER_i1_i1

  IALL_SCATTER_i1_i1=ScatterWith_i1_i1(hpf_iand_i1,-1, &
                                         array,base,indx1,mask)
END FUNCTION IALL_SCATTER_i1_i1
FUNCTION IANY_SCATTER_i1_i1(array,base,indx1,mask)
  INTEGER, intent(in)                         :: array(:)
  INTEGER, intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::IANY_SCATTER_i1_i1

  IANY_SCATTER_i1_i1=ScatterWith_i1_i1(hpf_ior_i1,0, &
                                       array,base,indx1,mask)
END FUNCTION IANY_SCATTER_i1_i1
FUNCTION IPARITY_SCATTER_i1_i1(array,base,indx1,mask)
  INTEGER, intent(in)                         :: array(:)
  INTEGER, intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::IPARITY_SCATTER_i1_i1

  IPARITY_SCATTER_i1_i1=ScatterWith_i1_i1(hpf_ieor_i1,0, &
                                      array,base,indx1,mask)
END FUNCTION IPARITY_SCATTER_i1_i1
FUNCTION COPY_SCATTER_i1_i1(array,base,indx1,mask)
  INTEGER, intent(in)                         :: array(:)
  INTEGER, intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::COPY_SCATTER_i1_i1

  COPY_SCATTER_i1_i1=ScatterWith_i1_i1(hpf_copy_i1,0, &
                                      array,base,indx1,mask)
END FUNCTION COPY_SCATTER_i1_i1
FUNCTION COPY_SCATTER_s1_s1(array,base,indx1,mask)
  REAL(sp), intent(in)                         :: array(:)
  REAL(sp), intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::COPY_SCATTER_s1_s1

  COPY_SCATTER_s1_s1=ScatterWith_s1_s1(hpf_copy_s1,0.0_sp, &
                                      array,base,indx1,mask)
END FUNCTION COPY_SCATTER_s1_s1
FUNCTION COPY_SCATTER_d1_d1(array,base,indx1,mask)
  REAL(dp), intent(in)                         :: array(:)
  REAL(dp), intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::COPY_SCATTER_d1_d1

  COPY_SCATTER_d1_d1=ScatterWith_d1_d1(hpf_copy_d1,0.0_dp, &
                                      array,base,indx1,mask)
END FUNCTION COPY_SCATTER_d1_d1
FUNCTION ALL_SCATTER_l1_i1(mask,base,indx1)
  LOGICAL, intent(in)                         :: mask(:)
  LOGICAL, intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(mask)) :: indx1(:)

  LOGICAL, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::ALL_SCATTER_l1_i1

  ALL_SCATTER_l1_i1=ScatterWith_l1_i1(hpf_and_l1,.TRUE., &
                                      mask,base,indx1)
END FUNCTION ALL_SCATTER_l1_i1
FUNCTION ANY_SCATTER_l1_i1(mask,base,indx1)
  LOGICAL, intent(in)                         :: mask(:)
  LOGICAL, intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(mask)) :: indx1(:)

  LOGICAL, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::ANY_SCATTER_l1_i1

  ANY_SCATTER_l1_i1=ScatterWith_l1_i1(hpf_or_l1,.FALSE., &
                                      mask,base,indx1)
END FUNCTION ANY_SCATTER_l1_i1
FUNCTION SUM_SCATTER_i2_i2(array,base,indx1,indx2,mask)
  INTEGER, intent(in)                         :: array(:,:)
  INTEGER, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER, dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2))::SUM_SCATTER_i2_i2

  SUM_SCATTER_i2_i2=ScatterWith_i2_i2(hpf_add_i1,0,array,base, &
                                      indx1,indx2,mask)
END FUNCTION SUM_SCATTER_i2_i2
FUNCTION SUM_SCATTER_s2_s2(array,base,indx1,indx2,mask)
  REAL(kind=sp), intent(in)                   :: array(:,:)
  REAL(kind=sp), intent(in)                   :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  REAL(kind=sp),dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2)) ::SUM_SCATTER_s2_s2

  SUM_SCATTER_s2_s2=ScatterWith_s2_s2(hpf_add_s1,0.0_sp,array,base, &
                                      indx1,indx2,mask)
END FUNCTION SUM_SCATTER_s2_s2
FUNCTION SUM_SCATTER_d2_d2(array,base,indx1,indx2,mask)
  REAL(kind=dp), intent(in)                   :: array(:,:)
  REAL(kind=dp), intent(in)                   :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  REAL(kind=dp),dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2))::SUM_SCATTER_d2_d2

  SUM_SCATTER_d2_d2=ScatterWith_d2_d2(hpf_add_d1,0.0_dp,array,base, &
                                      indx1,indx2,mask)
END FUNCTION SUM_SCATTER_d2_d2
FUNCTION PRODUCT_SCATTER_i2_i2(array,base,indx1,indx2,mask)
  INTEGER, intent(in)                         :: array(:,:)
  INTEGER, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER, dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2))::PRODUCT_SCATTER_i2_i2

  PRODUCT_SCATTER_i2_i2=ScatterWith_i2_i2(hpf_mult_i1,1,array,base, &
                                          indx1,indx2,mask)
END FUNCTION PRODUCT_SCATTER_i2_i2
FUNCTION PRODUCT_SCATTER_s2_s2(array,base,indx1,indx2,mask)
  REAL(kind=sp), intent(in)                   :: array(:,:)
  REAL(kind=sp), intent(in)                   :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  REAL(kind=sp), dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2))::PRODUCT_SCATTER_s2_s2

  PRODUCT_SCATTER_s2_s2=ScatterWith_s2_s2(hpf_mult_s1,1.0_sp,array,base, &
                                          indx1,indx2,mask)
END FUNCTION PRODUCT_SCATTER_s2_s2
FUNCTION PRODUCT_SCATTER_d2_d2(array,base,indx1,indx2,mask)
  REAL(kind=dp), intent(in)                   :: array(:,:)
  REAL(kind=dp), intent(in)                   :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  REAL(kind=dp),dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2)) ::PRODUCT_SCATTER_d2_d2

  PRODUCT_SCATTER_d2_d2=ScatterWith_d2_d2(hpf_mult_d1,1.0_dp,array,base, &
                                          indx1,indx2,mask)
END FUNCTION PRODUCT_SCATTER_d2_d2
FUNCTION COUNT_SCATTER_i2_i2(mask,base,indx1,indx2)
  LOGICAL, intent(in)                         :: mask(:,:)
  INTEGER, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(mask))  :: indx1(:,:)
  INTEGER, intent(in), dimension(size(mask))  :: indx2(:,:)

  INTEGER,dimension(lbound(base,dim=1):ubound(base,dim=1), &
                    lbound(base,dim=2):ubound(base,dim=2)) ::COUNT_SCATTER_i2_i2

  INTEGER,dimension(lbound(mask,dim=1):ubound(mask,dim=1), &
                    lbound(mask,dim=2):ubound(mask,dim=2)) :: temp

  WHERE (mask) 
     temp = 1
  ELSEWHERE
     temp = 0
  ENDWHERE
  COUNT_SCATTER_i2_i2=ScatterWith_i2_i2(hpf_add_i1,0, temp , base,indx1,indx2)
END FUNCTION COUNT_SCATTER_i2_i2
FUNCTION MAXVAL_SCATTER_i2_i2(array,base,indx1,indx2,mask)
  INTEGER, intent(in)                         :: array(:,:)
  INTEGER, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER, dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2))::MAXVAL_SCATTER_i2_i2

  MAXVAL_SCATTER_i2_i2=ScatterWith_i2_i2(hpf_MAX_i1,MINVAL(array), &
                                         array,base,indx1,indx2,mask)
END FUNCTION MAXVAL_SCATTER_i2_i2
FUNCTION MAXVAL_SCATTER_s2_s2(array,base,indx1,indx2,mask)
  REAL(kind=sp), intent(in)                         :: array(:,:)
  REAL(kind=sp), intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  REAL(kind=sp), dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2))::MAXVAL_SCATTER_s2_s2

  MAXVAL_SCATTER_s2_s2=ScatterWith_s2_s2(hpf_MAX_s1,MINVAL(array), &
                                         array,base,indx1,indx2,mask)
END FUNCTION MAXVAL_SCATTER_s2_s2
FUNCTION MAXVAL_SCATTER_d2_d2(array,base,indx1,indx2,mask)
  REAL(kind=dp), intent(in)                         :: array(:,:)
  REAL(kind=dp), intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  REAL(kind=dp), dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2))::MAXVAL_SCATTER_d2_d2

  MAXVAL_SCATTER_d2_d2=ScatterWith_d2_d2(hpf_MAX_d1,MINVAL(array), &
                                         array,base,indx1,indx2,mask)
END FUNCTION MAXVAL_SCATTER_d2_d2
FUNCTION MINVAL_SCATTER_i2_i2(array,base,indx1,indx2,mask)
  INTEGER, intent(in)                         :: array(:,:)
  INTEGER, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER, dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2))::MINVAL_SCATTER_i2_i2

  MINVAL_SCATTER_i2_i2=ScatterWith_i2_i2(hpf_MIN_i1,MAXVAL(array), &
                                         array,base,indx1,indx2,mask)
END FUNCTION MINVAL_SCATTER_i2_i2
FUNCTION MINVAL_SCATTER_s2_s2(array,base,indx1,indx2,mask)
  REAL(kind=sp), intent(in)                   :: array(:,:)
  REAL(kind=sp), intent(in)                   :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  REAL(kind=sp), dimension(lbound(base,dim=1):ubound(base,dim=1), &
                           lbound(base,dim=2):ubound(base,dim=2))::MINVAL_SCATTER_s2_s2

  MINVAL_SCATTER_s2_s2=ScatterWith_s2_s2(hpf_MIN_s1,MAXVAL(array), &
                                         array,base,indx1,indx2,mask)
END FUNCTION MINVAL_SCATTER_s2_s2
FUNCTION MINVAL_SCATTER_d2_d2(array,base,indx1,indx2,mask)
  REAL(kind=dp), intent(in)                   :: array(:,:)
  REAL(kind=dp), intent(in)                   :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  REAL(kind=dp),dimension(lbound(base,dim=1):ubound(base,dim=1), &
                          lbound(base,dim=2):ubound(base,dim=2)) ::MINVAL_SCATTER_d2_d2

  MINVAL_SCATTER_d2_d2=ScatterWith_d2_d2(hpf_MIN_d1,MAXVAL(array), &
                                         array,base,indx1,indx2,mask)
END FUNCTION MINVAL_SCATTER_d2_d2
FUNCTION IALL_SCATTER_i2_i2(array,base,indx1,indx2,mask)
  INTEGER, intent(in)                         :: array(:,:)
  INTEGER, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER,dimension(lbound(base,dim=1):ubound(base,dim=1), &
                    lbound(base,dim=2):ubound(base,dim=2)) ::IALL_SCATTER_i2_i2

  IALL_SCATTER_i2_i2=ScatterWith_i2_i2(hpf_iand_i1,-1, &
                                         array,base,indx1,indx2,mask)
END FUNCTION IALL_SCATTER_i2_i2
FUNCTION IANY_SCATTER_i2_i2(array,base,indx1,indx2,mask)
  INTEGER, intent(in)                         :: array(:,:)
  INTEGER, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER,dimension(lbound(base,dim=1):ubound(base,dim=1), &
                    lbound(base,dim=2):ubound(base,dim=2)) ::IANY_SCATTER_i2_i2

  IANY_SCATTER_i2_i2=ScatterWith_i2_i2(hpf_ior_i1,0, &
                                       array,base,indx1,indx2,mask)
END FUNCTION IANY_SCATTER_i2_i2
FUNCTION IPARITY_SCATTER_i2_i2(array,base,indx1,indx2,mask)
  INTEGER, intent(in)                         :: array(:,:)
  INTEGER, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER,dimension(lbound(base,dim=1):ubound(base,dim=1), &
                    lbound(base,dim=2):ubound(base,dim=2)) ::IPARITY_SCATTER_i2_i2

  IPARITY_SCATTER_i2_i2=ScatterWith_i2_i2(hpf_ieor_i1,0, &
                                      array,base,indx1,indx2,mask)
END FUNCTION IPARITY_SCATTER_i2_i2
FUNCTION COPY_SCATTER_i2_i2(array,base,indx1,indx2,mask)
  INTEGER, intent(in)                         :: array(:,:)
  INTEGER, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER,dimension(lbound(base,dim=1):ubound(base,dim=1), &
                    lbound(base,dim=2):ubound(base,dim=2)) ::COPY_SCATTER_i2_i2

  COPY_SCATTER_i2_i2=ScatterWith_i2_i2(hpf_copy_i1,0, &
                                      array,base,indx1,indx2,mask)
END FUNCTION COPY_SCATTER_i2_i2
FUNCTION COPY_SCATTER_s2_s2(array,base,indx1,indx2,mask)
  REAL(sp), intent(in)                         :: array(:,:)
  REAL(sp), intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER,dimension(lbound(base,dim=1):ubound(base,dim=1), &
                    lbound(base,dim=2):ubound(base,dim=2)) ::COPY_SCATTER_s2_s2

  COPY_SCATTER_s2_s2=ScatterWith_s2_s2(hpf_copy_s1,0.0_sp, &
                                      array,base,indx1,indx2,mask)
END FUNCTION COPY_SCATTER_s2_s2
FUNCTION COPY_SCATTER_d2_d2(array,base,indx1,indx2,mask)
  REAL(dp), intent(in)                         :: array(:,:)
  REAL(dp), intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER,dimension(lbound(base,dim=1):ubound(base,dim=1), &
                    lbound(base,dim=2):ubound(base,dim=2)) ::COPY_SCATTER_d2_d2

  COPY_SCATTER_d2_d2=ScatterWith_d2_d2(hpf_copy_d1,0.0_dp, &
                                      array,base,indx1,indx2,mask)
END FUNCTION COPY_SCATTER_d2_d2
FUNCTION ALL_SCATTER_l2_i2(mask,base,indx1,indx2)
  LOGICAL, intent(in)                         :: mask(:,:)
  LOGICAL, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(mask)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(mask)) :: indx2(:,:)

  LOGICAL,dimension(lbound(base,dim=1):ubound(base,dim=1), &
                    lbound(base,dim=2):ubound(base,dim=2)) ::ALL_SCATTER_l2_i2

  ALL_SCATTER_l2_i2=ScatterWith_l2_i2(hpf_and_l1,.TRUE., &
                                      mask,base,indx1,indx2)
END FUNCTION ALL_SCATTER_l2_i2
FUNCTION ANY_SCATTER_l2_i2(mask,base,indx1,indx2)
  LOGICAL, intent(in)                         :: mask(:,:)
  LOGICAL, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(mask)) :: indx1(:,:)
  INTEGER, intent(in), dimension(size(mask)) :: indx2(:,:)

  LOGICAL,dimension(lbound(base,dim=1):ubound(base,dim=1), &
                    lbound(base,dim=2):ubound(base,dim=2)) ::ANY_SCATTER_l2_i2

  ANY_SCATTER_l2_i2=ScatterWith_l2_i2(hpf_or_l1,.FALSE., &
                                      mask,base,indx1,indx2)
END FUNCTION ANY_SCATTER_l2_i2
FUNCTION SUM_SCATTER_i2_i1(array,base,indx1,indx2,mask)
  INTEGER, intent(in)                         :: array(:)
  INTEGER, intent(in)                         :: base(:,:)
  INTEGER, intent(in)                         :: indx1(:)
  INTEGER, intent(in)                         :: indx2(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER, dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2))::SUM_SCATTER_i2_i1

  SUM_SCATTER_i2_i1=ScatterWith_i2_i1(hpf_add_i1,0,array,base, &
                                      indx1,indx2,mask)
END FUNCTION SUM_SCATTER_i2_i1
FUNCTION SUM_SCATTER_s2_s1(array,base,indx1,indx2,mask)
  REAL(kind=sp), intent(in)                   :: array(:)
  REAL(kind=sp), intent(in)                   :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:)
  LOGICAL, intent(in), optional               :: mask(:)

  REAL(kind=sp),dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2)) ::SUM_SCATTER_s2_s1

  SUM_SCATTER_s2_s1=ScatterWith_s2_s1(hpf_add_s1,0.0_sp,array,base, &
                                      indx1,indx2,mask)
END FUNCTION SUM_SCATTER_s2_s1
FUNCTION SUM_SCATTER_d2_d1(array,base,indx1,indx2,mask)
  REAL(kind=dp), intent(in)                   :: array(:)
  REAL(kind=dp), intent(in)                   :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:)
  LOGICAL, intent(in), optional               :: mask(:)

  REAL(kind=dp),dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2))::SUM_SCATTER_d2_d1

  SUM_SCATTER_d2_d1=ScatterWith_d2_d1(hpf_add_d1,0.0_dp,array,base, &
                                      indx1,indx2,mask)
END FUNCTION SUM_SCATTER_d2_d1
FUNCTION PRODUCT_SCATTER_i2_i1(array,base,indx1,indx2,mask)
  INTEGER, intent(in)                         :: array(:)
  INTEGER, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER, dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2))::PRODUCT_SCATTER_i2_i1

  PRODUCT_SCATTER_i2_i1=ScatterWith_i2_i1(hpf_mult_i1,1,array,base, &
                                          indx1,indx2,mask)
END FUNCTION PRODUCT_SCATTER_i2_i1
FUNCTION PRODUCT_SCATTER_s2_s1(array,base,indx1,indx2,mask)
  REAL(kind=sp), intent(in)                   :: array(:)
  REAL(kind=sp), intent(in)                   :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:)
  LOGICAL, intent(in), optional               :: mask(:)

  REAL(kind=sp), dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2))::PRODUCT_SCATTER_s2_s1

  PRODUCT_SCATTER_s2_s1=ScatterWith_s2_s1(hpf_mult_s1,1.0_sp,array,base, &
                                          indx1,indx2,mask)
END FUNCTION PRODUCT_SCATTER_s2_s1
FUNCTION PRODUCT_SCATTER_d2_d1(array,base,indx1,indx2,mask)
  REAL(kind=dp), intent(in)                   :: array(:)
  REAL(kind=dp), intent(in)                   :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:)
  LOGICAL, intent(in), optional               :: mask(:)

  REAL(kind=dp),dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2)) ::PRODUCT_SCATTER_d2_d1

  PRODUCT_SCATTER_d2_d1=ScatterWith_d2_d1(hpf_mult_d1,1.0_dp,array,base, &
                                          indx1,indx2,mask)
END FUNCTION PRODUCT_SCATTER_d2_d1
FUNCTION COUNT_SCATTER_i2_i1(mask,base,indx1,indx2)
  LOGICAL, intent(in)                         :: mask(:)
  INTEGER, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(mask))  :: indx1(:)
  INTEGER, intent(in), dimension(size(mask))  :: indx2(:)

  INTEGER,dimension(lbound(base,dim=1):ubound(base,dim=1), &
                    lbound(base,dim=2):ubound(base,dim=2)) ::COUNT_SCATTER_i2_i1

  INTEGER,dimension(lbound(mask,dim=1):ubound(mask,dim=1)) :: temp

  WHERE (mask) 
     temp = 1
  ELSEWHERE
     temp = 0
  ENDWHERE
  COUNT_SCATTER_i2_i1=ScatterWith_i2_i1(hpf_add_i1,0, temp , base,indx1,indx2)
END FUNCTION COUNT_SCATTER_i2_i1
FUNCTION MAXVAL_SCATTER_i2_i1(array,base,indx1,indx2,mask)
  INTEGER, intent(in)                         :: array(:)
  INTEGER, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER, dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2))::MAXVAL_SCATTER_i2_i1

  MAXVAL_SCATTER_i2_i1=ScatterWith_i2_i1(hpf_MAX_i1,MINVAL(array), &
                                         array,base,indx1,indx2,mask)
END FUNCTION MAXVAL_SCATTER_i2_i1
FUNCTION MAXVAL_SCATTER_s2_s1(array,base,indx1,indx2,mask)
  REAL(kind=sp), intent(in)                         :: array(:)
  REAL(kind=sp), intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:)
  LOGICAL, intent(in), optional               :: mask(:)

  REAL(kind=sp), dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2))::MAXVAL_SCATTER_s2_s1

  MAXVAL_SCATTER_s2_s1=ScatterWith_s2_s1(hpf_MAX_s1,MINVAL(array), &
                                         array,base,indx1,indx2,mask)
END FUNCTION MAXVAL_SCATTER_s2_s1
FUNCTION MAXVAL_SCATTER_d2_d1(array,base,indx1,indx2,mask)
  REAL(kind=dp), intent(in)                   :: array(:)
  REAL(kind=dp), intent(in)                   :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:)
  LOGICAL, intent(in), optional               :: mask(:)

  REAL(kind=dp), dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2))::MAXVAL_SCATTER_d2_d1

  MAXVAL_SCATTER_d2_d1=ScatterWith_d2_d1(hpf_MAX_d1,MINVAL(array), &
                                         array,base,indx1,indx2,mask)
END FUNCTION MAXVAL_SCATTER_d2_d1
FUNCTION MINVAL_SCATTER_i2_i1(array,base,indx1,indx2,mask)
  INTEGER, intent(in)                         :: array(:)
  INTEGER, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER, dimension(lbound(base,dim=1):ubound(base,dim=1), &
                     lbound(base,dim=2):ubound(base,dim=2))::MINVAL_SCATTER_i2_i1

  MINVAL_SCATTER_i2_i1=ScatterWith_i2_i1(hpf_MIN_i1,MAXVAL(array), &
                                         array,base,indx1,indx2,mask)
END FUNCTION MINVAL_SCATTER_i2_i1
FUNCTION MINVAL_SCATTER_s2_s1(array,base,indx1,indx2,mask)
  REAL(kind=sp), intent(in)                   :: array(:)
  REAL(kind=sp), intent(in)                   :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:)
  LOGICAL, intent(in), optional               :: mask(:)

  REAL(kind=sp), dimension(lbound(base,dim=1):ubound(base,dim=1), &
                           lbound(base,dim=2):ubound(base,dim=2))::MINVAL_SCATTER_s2_s1

  MINVAL_SCATTER_s2_s1=ScatterWith_s2_s1(hpf_MIN_s1,MAXVAL(array), &
                                         array,base,indx1,indx2,mask)
END FUNCTION MINVAL_SCATTER_s2_s1
FUNCTION MINVAL_SCATTER_d2_d1(array,base,indx1,indx2,mask)
  REAL(kind=dp), intent(in)                   :: array(:)
  REAL(kind=dp), intent(in)                   :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:)
  LOGICAL, intent(in), optional               :: mask(:)

  REAL(kind=dp),dimension(lbound(base,dim=1):ubound(base,dim=1), &
                          lbound(base,dim=2):ubound(base,dim=2)) ::MINVAL_SCATTER_d2_d1

  MINVAL_SCATTER_d2_d1=ScatterWith_d2_d1(hpf_MIN_d1,MAXVAL(array), &
                                         array,base,indx1,indx2,mask)
END FUNCTION MINVAL_SCATTER_d2_d1
FUNCTION IALL_SCATTER_i2_i1(array,base,indx1,indx2,mask)
  INTEGER, intent(in)                         :: array(:)
  INTEGER, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER,dimension(lbound(base,dim=1):ubound(base,dim=1), &
                    lbound(base,dim=2):ubound(base,dim=2)) ::IALL_SCATTER_i2_i1

  IALL_SCATTER_i2_i1=ScatterWith_i2_i1(hpf_iand_i1,-1, &
                                         array,base,indx1,indx2,mask)
END FUNCTION IALL_SCATTER_i2_i1
FUNCTION IANY_SCATTER_i2_i1(array,base,indx1,indx2,mask)
  INTEGER, intent(in)                         :: array(:)
  INTEGER, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER,dimension(lbound(base,dim=1):ubound(base,dim=1), &
                    lbound(base,dim=2):ubound(base,dim=2)) ::IANY_SCATTER_i2_i1

  IANY_SCATTER_i2_i1=ScatterWith_i2_i1(hpf_ior_i1,0, &
                                       array,base,indx1,indx2,mask)
END FUNCTION IANY_SCATTER_i2_i1
FUNCTION IPARITY_SCATTER_i2_i1(array,base,indx1,indx2,mask)
  INTEGER, intent(in)                         :: array(:)
  INTEGER, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER,dimension(lbound(base,dim=1):ubound(base,dim=1), &
                    lbound(base,dim=2):ubound(base,dim=2)) ::IPARITY_SCATTER_i2_i1

  IPARITY_SCATTER_i2_i1=ScatterWith_i2_i1(hpf_ieor_i1,0, &
                                      array,base,indx1,indx2,mask)
END FUNCTION IPARITY_SCATTER_i2_i1
FUNCTION COPY_SCATTER_i2_i1(array,base,indx1,indx2,mask)
  INTEGER, intent(in)                         :: array(:)
  INTEGER, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER,dimension(lbound(base,dim=1):ubound(base,dim=1), &
                    lbound(base,dim=2):ubound(base,dim=2)) ::COPY_SCATTER_i2_i1

  COPY_SCATTER_i2_i1=ScatterWith_i2_i1(hpf_copy_i1,0, &
                                      array,base,indx1,indx2,mask)
END FUNCTION COPY_SCATTER_i2_i1
FUNCTION COPY_SCATTER_s2_s1(array,base,indx1,indx2,mask)
  REAL(sp), intent(in)                         :: array(:)
  REAL(sp), intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER,dimension(lbound(base,dim=1):ubound(base,dim=1), &
                    lbound(base,dim=2):ubound(base,dim=2)) ::COPY_SCATTER_s2_s1

  COPY_SCATTER_s2_s1=ScatterWith_s2_s1(hpf_copy_s1,0.0_sp, &
                                      array,base,indx1,indx2,mask)
END FUNCTION COPY_SCATTER_s2_s1
FUNCTION COPY_SCATTER_d2_d1(array,base,indx1,indx2,mask)
  REAL(dp), intent(in)                         :: array(:)
  REAL(dp), intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:)
  INTEGER, intent(in), dimension(size(array)) :: indx2(:)
  LOGICAL, intent(in), optional               :: mask(:)

  INTEGER,dimension(lbound(base,dim=1):ubound(base,dim=1), &
                    lbound(base,dim=2):ubound(base,dim=2)) ::COPY_SCATTER_d2_d1

  COPY_SCATTER_d2_d1=ScatterWith_d2_d1(hpf_copy_d1,0.0_dp, &
                                      array,base,indx1,indx2,mask)
END FUNCTION COPY_SCATTER_d2_d1
FUNCTION ALL_SCATTER_l2_i1(mask,base,indx1,indx2)
  LOGICAL, intent(in)                         :: mask(:)
  LOGICAL, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(mask)) :: indx1(:)
  INTEGER, intent(in), dimension(size(mask)) :: indx2(:)

  LOGICAL,dimension(lbound(base,dim=1):ubound(base,dim=1), &
                    lbound(base,dim=2):ubound(base,dim=2)) ::ALL_SCATTER_l2_i1

  ALL_SCATTER_l2_i1=ScatterWith_l2_i1(hpf_and_l1,.TRUE., &
                                      mask,base,indx1,indx2)
END FUNCTION ALL_SCATTER_l2_i1
FUNCTION ANY_SCATTER_l2_i1(mask,base,indx1,indx2)
  LOGICAL, intent(in)                         :: mask(:)
  LOGICAL, intent(in)                         :: base(:,:)
  INTEGER, intent(in), dimension(size(mask)) :: indx1(:)
  INTEGER, intent(in), dimension(size(mask)) :: indx2(:)

  LOGICAL,dimension(lbound(base,dim=1):ubound(base,dim=1), &
                    lbound(base,dim=2):ubound(base,dim=2)) ::ANY_SCATTER_l2_i1

  ANY_SCATTER_l2_i1=ScatterWith_l2_i1(hpf_or_l1,.FALSE., &
                                      mask,base,indx1,indx2)
END FUNCTION ANY_SCATTER_l2_i1
FUNCTION SUM_SCATTER_i1_i2(array,base,indx1,mask)
  INTEGER, intent(in)                :: array(:,:)
  INTEGER, intent(in)                :: base(:)
  INTEGER, intent(in)                :: indx1(:,:)
  LOGICAL, intent(in), optional      :: mask(:,:)

  INTEGER, dimension(lbound(base,dim=1):ubound(base,dim=1))::SUM_SCATTER_i1_i2

  SUM_SCATTER_i1_i2=ScatterWith_i1_i2(hpf_add_i1,0,array,base,indx1,mask)
END FUNCTION SUM_SCATTER_i1_i2
FUNCTION SUM_SCATTER_s1_s2(array,base,indx1,mask)
  REAL(kind=sp), intent(in)                   :: array(:,:)
  REAL(kind=sp), intent(in)                   :: base(:)
  INTEGER, intent(in)                         :: indx1(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  REAL(kind=sp), dimension(lbound(base,dim=1): &
                           ubound(base,dim=1))::SUM_SCATTER_s1_s2

  SUM_SCATTER_s1_s2=ScatterWith_s1_s2(hpf_add_s1,0.0_sp,array,base,indx1,mask)
END FUNCTION SUM_SCATTER_s1_s2
FUNCTION SUM_SCATTER_d1_d2(array,base,indx1,mask)
  REAL(kind=dp), intent(in)                   :: array(:,:)
  REAL(kind=dp), intent(in)                   :: base(:)
  INTEGER, intent(in)                         :: indx1(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  REAL(kind=dp), dimension(lbound(base,dim=1): &
                           ubound(base,dim=1))::SUM_SCATTER_d1_d2

  SUM_SCATTER_d1_d2=ScatterWith_d1_d2(hpf_add_d1,0.0_dp,array,base,indx1,mask)
END FUNCTION SUM_SCATTER_d1_d2
FUNCTION PRODUCT_SCATTER_i1_i2(array,base,indx1,mask)
  INTEGER, intent(in)                         :: array(:,:)
  INTEGER, intent(in)                         :: base(:)
  INTEGER, intent(in)                         :: indx1(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::PRODUCT_SCATTER_i1_i2

  PRODUCT_SCATTER_i1_i2=ScatterWith_i1_i2(hpf_mult_i1,1,array,base,indx1,mask)
END FUNCTION PRODUCT_SCATTER_i1_i2
FUNCTION PRODUCT_SCATTER_s1_s2(array,base,indx1,mask)
  REAL(kind=sp), intent(in)                   :: array(:,:)
  REAL(kind=sp), intent(in)                   :: base(:)
  INTEGER                                     :: indx1(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  REAL(kind=sp), dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::PRODUCT_SCATTER_s1_s2

  PRODUCT_SCATTER_s1_s2=ScatterWith_s1_s2(hpf_mult_s1,1.0_sp,array,base,indx1,mask)
END FUNCTION PRODUCT_SCATTER_s1_s2
FUNCTION PRODUCT_SCATTER_d1_d2(array,base,indx1,mask)
  REAL(kind=dp), intent(in)                   :: array(:,:)
  REAL(kind=dp), intent(in)                   :: base(:)
  INTEGER, intent(in)                         :: indx1(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  REAL(kind=dp), dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::PRODUCT_SCATTER_d1_d2

  PRODUCT_SCATTER_d1_d2=ScatterWith_d1_d2(hpf_mult_d1,1.0_dp,array,base,indx1,mask)
END FUNCTION PRODUCT_SCATTER_d1_d2
FUNCTION COUNT_SCATTER_i1_i2(mask,base,indx1)
  LOGICAL, intent(in)                         :: mask(:,:)
  INTEGER, intent(in)                         :: base(:)
  INTEGER, intent(in)                         :: indx1(:,:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::COUNT_SCATTER_i1_i2

  INTEGER,dimension(lbound(mask,dim=1):ubound(mask,dim=1), &
                    lbound(mask,dim=2):ubound(mask,dim=2)) :: temp

  WHERE (mask) 
     temp = 1
  ELSEWHERE
     temp = 0
  ENDWHERE
  COUNT_SCATTER_i1_i2=ScatterWith_i1_i2(hpf_add_i1,0, temp, base,indx1)
END FUNCTION COUNT_SCATTER_i1_i2
FUNCTION MAXVAL_SCATTER_i1_i2(array,base,indx1,mask)
  INTEGER, intent(in)                         :: array(:,:)
  INTEGER, intent(in)                         :: base(:)
  INTEGER, intent(in)                         :: indx1(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::MAXVAL_SCATTER_i1_i2

  MAXVAL_SCATTER_i1_i2=ScatterWith_i1_i2(hpf_MAX_i1,MINVAL(array), &
                                         array,base,indx1,mask)
END FUNCTION MAXVAL_SCATTER_i1_i2
FUNCTION MAXVAL_SCATTER_s1_s2(array,base,indx1,mask)
  REAL(kind=sp), intent(in)                         :: array(:,:)
  REAL(kind=sp), intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  REAL(kind=sp), dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::MAXVAL_SCATTER_s1_s2

  MAXVAL_SCATTER_s1_s2=ScatterWith_s1_s2(hpf_MAX_s1,MINVAL(array), &
                                         array,base,indx1,mask)
END FUNCTION MAXVAL_SCATTER_s1_s2
FUNCTION MAXVAL_SCATTER_d1_d2(array,base,indx1,mask)
  REAL(kind=dp), intent(in)                         :: array(:,:)
  REAL(kind=dp), intent(in)                         :: base(:)
  INTEGER, intent(in)                         :: indx1(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  REAL(kind=dp), dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::MAXVAL_SCATTER_d1_d2

  MAXVAL_SCATTER_d1_d2=ScatterWith_d1_d2(hpf_MAX_d1,MINVAL(array), &
                                         array,base,indx1,mask)
END FUNCTION MAXVAL_SCATTER_d1_d2
FUNCTION MINVAL_SCATTER_i1_i2(array,base,indx1,mask)
  INTEGER, intent(in)                         :: array(:,:)
  INTEGER, intent(in)                         :: base(:)
  INTEGER, intent(in)                         :: indx1(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::MINVAL_SCATTER_i1_i2

  MINVAL_SCATTER_i1_i2=ScatterWith_i1_i2(hpf_MIN_i1,MAXVAL(array), &
                                         array,base,indx1,mask)
END FUNCTION MINVAL_SCATTER_i1_i2
FUNCTION MINVAL_SCATTER_s1_s2(array,base,indx1,mask)
  REAL(kind=sp), intent(in)                   :: array(:,:)
  REAL(kind=sp), intent(in)                   :: base(:)
  INTEGER, intent(in)                         :: indx1(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  REAL(kind=sp), dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::MINVAL_SCATTER_s1_s2

  MINVAL_SCATTER_s1_s2=ScatterWith_s1_s2(hpf_MIN_s1,MAXVAL(array), &
                                         array,base,indx1,mask)
END FUNCTION MINVAL_SCATTER_s1_s2
FUNCTION MINVAL_SCATTER_d1_d2(array,base,indx1,mask)
  REAL(kind=dp), intent(in)                   :: array(:,:)
  REAL(kind=dp), intent(in)                   :: base(:)
  INTEGER, intent(in)                         :: indx1(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  REAL(kind=dp), dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::MINVAL_SCATTER_d1_d2

  MINVAL_SCATTER_d1_d2=ScatterWith_d1_d2(hpf_MIN_d1,MAXVAL(array), &
                                         array,base,indx1,mask)
END FUNCTION MINVAL_SCATTER_d1_d2
FUNCTION IALL_SCATTER_i1_i2(array,base,indx1,mask)
  INTEGER, intent(in)                         :: array(:,:)
  INTEGER, intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::IALL_SCATTER_i1_i2

  IALL_SCATTER_i1_i2=ScatterWith_i1_i2(hpf_iand_i1,-1, &
                                         array,base,indx1,mask)
END FUNCTION IALL_SCATTER_i1_i2
FUNCTION IANY_SCATTER_i1_i2(array,base,indx1,mask)
  INTEGER, intent(in)                         :: array(:,:)
  INTEGER, intent(in)                         :: base(:)
  INTEGER, intent(in)                         :: indx1(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::IANY_SCATTER_i1_i2

  IANY_SCATTER_i1_i2=ScatterWith_i1_i2(hpf_ior_i1,0, &
                                       array,base,indx1,mask)
END FUNCTION IANY_SCATTER_i1_i2
FUNCTION IPARITY_SCATTER_i1_i2(array,base,indx1,mask)
  INTEGER, intent(in)                         :: array(:,:)
  INTEGER, intent(in)                         :: base(:)
  INTEGER, intent(in)                         :: indx1(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::IPARITY_SCATTER_i1_i2

  IPARITY_SCATTER_i1_i2=ScatterWith_i1_i2(hpf_ieor_i1,0, &
                                      array,base,indx1,mask)
END FUNCTION IPARITY_SCATTER_i1_i2
FUNCTION COPY_SCATTER_i1_i2(array,base,indx1,mask)
  INTEGER, intent(in)                         :: array(:,:)
  INTEGER, intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::COPY_SCATTER_i1_i2

  COPY_SCATTER_i1_i2=ScatterWith_i1_i2(hpf_copy_i1,0, &
                                      array,base,indx1,mask)
END FUNCTION COPY_SCATTER_i1_i2
FUNCTION COPY_SCATTER_s1_s2(array,base,indx1,mask)
  REAL(sp), intent(in)                         :: array(:,:)
  REAL(sp), intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::COPY_SCATTER_s1_s2

  COPY_SCATTER_s1_s2=ScatterWith_s1_s2(hpf_copy_s1,0.0_sp, &
                                      array,base,indx1,mask)
END FUNCTION COPY_SCATTER_s1_s2
FUNCTION COPY_SCATTER_d1_d2(array,base,indx1,mask)
  REAL(dp), intent(in)                         :: array(:,:)
  REAL(dp), intent(in)                         :: base(:)
  INTEGER, intent(in), dimension(size(array)) :: indx1(:,:)
  LOGICAL, intent(in), optional               :: mask(:,:)

  INTEGER, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::COPY_SCATTER_d1_d2

  COPY_SCATTER_d1_d2=ScatterWith_d1_d2(hpf_copy_d1,0.0_dp, &
                                      array,base,indx1,mask)
END FUNCTION COPY_SCATTER_d1_d2
FUNCTION ALL_SCATTER_l1_i2(mask,base,indx1)
  LOGICAL, intent(in)                         :: mask(:,:)
  LOGICAL, intent(in)                         :: base(:)
  INTEGER, intent(in)                         :: indx1(:,:)

  LOGICAL, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::ALL_SCATTER_l1_i2

  ALL_SCATTER_l1_i2=ScatterWith_l1_i2(hpf_and_l1,.TRUE., &
                                      mask,base,indx1)
END FUNCTION ALL_SCATTER_l1_i2
FUNCTION ANY_SCATTER_l1_i2(mask,base,indx1)
  LOGICAL, intent(in)                         :: mask(:,:)
  LOGICAL, intent(in)                         :: base(:)
  INTEGER, intent(in)                         :: indx1(:,:)

  LOGICAL, dimension(lbound(base,dim=1):  &
                     ubound(base,dim=1))::ANY_SCATTER_l1_i2

  ANY_SCATTER_l1_i2=ScatterWith_l1_i2(hpf_or_l1,.FALSE., &
                                      mask,base,indx1)
END FUNCTION ANY_SCATTER_l1_i2
END MODULE HPF_Scatter
