package BOutilities.BObrowser;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public abstract class BrowserNodeContentView extends Panel implements ItemListener
{	
	
	private Hashtable reverseMap;
	
	public BrowserNodeContentView() {
		reverseMap= new Hashtable();
	}
	
	public abstract void replaceBrowserNode(BrowserNode node);
	
	public abstract void removeBrowserNode();
	
	public void observe(BrowserNodeListView view) {
		reverseMap.put(view.getList(), view);
		view.getList().addItemListener(this);
	}
	
	public void itemStateChanged(ItemEvent e) {
		BrowserNodeListView view= (BrowserNodeListView) reverseMap.get(e.getItemSelectable());
		
		int index= ((Integer) e.getItem()).intValue();
		BrowserNode selected= view.getNodeAt(index);
		
		if(selected.hasContent())
			replaceBrowserNode(selected);
		else
			removeBrowserNode();
	}
}
