package BOutilities.BOcanvas;

import java.awt.*;

public class TextCanvas extends Canvas {

	private String text;
		
	public TextCanvas(String text) {
		this.text= text;
	}
	
	public void setText(String text) {
		this.text= text;
		repaint();
	}
	
	public void paint(Graphics g) {
		Dimension d= getSize();
		FontMetrics fm = getFontMetrics(getFont());

		int baseline = d.height - fm.getMaxDescent();
		g.drawString(text, d.width/2 - fm.stringWidth(text)/2, baseline);
	}
		
	public Dimension getPreferredSize() {
		return getMinimumSize();
	}
	
	
	public Dimension getMinimumSize () {		
		FontMetrics fm = getFontMetrics(getFont());
		int width = fm.stringWidth(text);
		int height = fm.getHeight();

		return new Dimension(width + 8, height + 8);
	}
}
