package backoffice.BOgui;

import backoffice.BOgui.*;
import backoffice.BOkernel.*;
import BOutilities.BOcanvas.*;

import java.awt.*;
import java.awt.event.*;

public class AboutDialog extends Dialog
{							
	FontMetrics metrics;
	int tHeight;
	int width = 200, height = 300;

	public AboutDialog(Frame frame) {
		super(frame, "About BackOffice", true);
		
		this.makeContent();
	}
	
	protected void DrawCenter (int line, String text, Graphics g) {
		int tWidth = metrics.charsWidth (text.toCharArray (), 0, text.length ());
		g.drawString (text, (width - tWidth) / 2, tHeight * line + 30);
	}
	
	public void paint (Graphics g) {
		Dimension d = getSize ();
		g.setColor (Color.lightGray);
		g.fillRect (0, 0, d.width - 1, d.height - 1);
		g.setColor (Color.black);
		metrics = g.getFontMetrics ();
		tHeight = metrics.getHeight ();
		DrawCenter (1, "Back Office System", g);
		DrawCenter (3, "Java Tutorial Example", g);
		DrawCenter (4, "Version 1.01", g);
		DrawCenter (6, "Written by:", g);
		DrawCenter (7, "Kai-Uwe Maetzel at Ubilab,", g);
		DrawCenter (8, "Union Bank Of Switzerland", g);
		DrawCenter (10, "Adapted by:", g);
		DrawCenter (11, "Walter Brunauer", g);
		DrawCenter (12, "TakeFive", g);
		Toolkit toolkit= getToolkit ();
		Image pig= toolkit.getImage ("./BOgui/BOimages/pig.gif");
		if (pig != null)
			g.drawImage (pig, (width - pig.getWidth (this)) / 2, tHeight * 13 + 30, this);
	}

	private void makeContent() {
			
		WindowListener wl= new WindowAdapter() {
			public void windowClosing(WindowEvent event) {
				dispose();
			}
		};
		this.addWindowListener(wl);
		
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints constraint = new GridBagConstraints();
	
		setLayout (gridbag);

		constraint.fill = GridBagConstraints.BOTH;
		constraint.weightx = 1.0;
		constraint.weighty = 1.0;

		constraint.gridwidth = GridBagConstraints.REMAINDER;
//		constraint.gridheight = 1;
		constraint.fill = GridBagConstraints.HORIZONTAL;
		constraint.anchor = GridBagConstraints.SOUTH;

		Button button= new Button("OK");
		gridbag.setConstraints(button, constraint);		
		
		ActionListener quitter= new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				dispose();
			}
		};
		
		button.addActionListener(quitter);
		add(button);

		setSize(width, height);
		setVisible (true);
	}
}
