package backoffice.BOgui;

import backoffice.BOgui.*;
import backoffice.BOkernel.*;
import BOutilities.BOcanvas.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class BackOfficeFrame extends Frame
{

	final static private String 
		FILE= "File",
		STORES= "Deal stores ...",
		ABOUT= "About...",
		EXIT= "Close";
							
	protected BackOffice office;
	protected BackOfficeFrame officeFrame;
	
	public BackOfficeFrame(BackOffice backOffice, String title) {
		super(title);
		office= backOffice;
		officeFrame= this;
		
		makeMenuBar();
		makeContent();
		installEventHandling();
	}
	
	private void makeMenuBar() {
		MenuBar b= new MenuBar();
		Menu m= new Menu(FILE, true);
		MenuItem i= new MenuItem(ABOUT);
		
		ActionListener show= new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				new AboutDialog(officeFrame);
			}
		};
		i.addActionListener(show);
		
		m.add(i);
		m.addSeparator();

		i= new MenuItem(EXIT);
		
		ActionListener quitter= new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				office.quit();
			}
		};
		i.addActionListener(quitter);
		
		m.add(i);

		b.add(m);
		setMenuBar(b);
	}
	
	private void installEventHandling() {
		WindowListener wl= new WindowAdapter() {
			public void windowClosing(WindowEvent event) {
				office.quit();
			}
		};
		this.addWindowListener(wl);
	}

	
	private void makeContent() {
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints constraint = new GridBagConstraints();
	
		setLayout(gridbag);
		
		constraint.fill = GridBagConstraints.BOTH;
		constraint.weightx = 1.0;
		constraint.weighty = 1.0;
		constraint.gridwidth =  GridBagConstraints.REMAINDER;    
		constraint.gridheight = 3;

		Component component= new ImageCanvas("./BOgui/BOimages/team.gif");
		gridbag.setConstraints(component, constraint);
		add(component);
		
		constraint.anchor= GridBagConstraints.CENTER;
		constraint.insets= new Insets(5,5,0,5);
		constraint.gridheight = 1;       
		
		Button button= new Button(STORES);
		gridbag.setConstraints(button, constraint);		
		add(button);
		button.addActionListener(dealStoreListener());
		
		setSize(150,150);
		
		pack();
	}
	
	private ActionListener dealStoreListener() {
		return new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				(new DealStoreBrowser(office, BackOfficeFrame.this)).show();
			}
		};
	}	
}
