package backoffice.BOgui;

import backoffice.BOkernel.*;
import BOutilities.BObrowser.*;
import BOutilities.BOcanvas.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.*;

class DealView extends BrowserNodeContentView
{

	private TextArea todo, running, history;
	
	DealView() {
		makeContent();
	}
	
	private void makeContent() {
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints constraint = new GridBagConstraints();
	
		setLayout(gridbag);
		
		constraint.fill = GridBagConstraints.BOTH;
		constraint.weightx = 1.0;
		constraint.weighty = 1.0;
		constraint.gridwidth = GridBagConstraints.REMAINDER;
		constraint.gridheight = 1;
	
		// transactions not yet processed
		TextCanvas tc= new TextCanvas("Instruction List");
		gridbag.setConstraints(tc, constraint);
		add(tc);
		todo= new TextArea(5,3);
		gridbag.setConstraints(todo, constraint);
		add(todo);
		
		// running transaction
		tc= new TextCanvas("Running Transaction");
		gridbag.setConstraints(tc, constraint);
		add(tc);
		running= new TextArea(2,3);
		gridbag.setConstraints(running, constraint);
		add(running);
		
		// historic transactions
		tc= new TextCanvas("Historic Instruction List");
		gridbag.setConstraints(tc, constraint);
		add(tc);
		history= new TextArea(5,3);
		gridbag.setConstraints(history, constraint);
		add(history);
	}
	
	public void replaceBrowserNode(BrowserNode node) {
		
		removeBrowserNode();
				
		if(node instanceof BODeal) {
			// todo
			BODeal deal= (BODeal) node;
			Enumeration e= deal.transactions();
			while(e.hasMoreElements()) {
				BOTransaction t= (BOTransaction) e.nextElement();
				todo.append(t.toString() + "\n");
			}
			
			// running
			if(deal.isBeingProcessed())
				running.append(deal.inProcess().toString());
			
			//history
			e= deal.history();
			while(e.hasMoreElements()) {
				BOTransaction t= (BOTransaction) e.nextElement();
				history.append(t.toString() + "\n");
			}
		}
	}
	
	public void removeBrowserNode() {
		todo.setText("");
		running.setText("");
		history.setText("");
	}
}

public class DealStoreBrowser extends Browser 
	implements BrowserNodeViewFactory
{
		
	public DealStoreBrowser(BackOffice backOffice, Frame parent) {
		super("Deal Store Browser", parent);
		
		initialize(this);
		setRoot(backOffice);
	}
	
	public BrowserNodeListView createBrowserNodeListView() {
		return new BrowserNodeListView();
	}
	
	public BrowserNodeContentView createBrowserNodeContentView() {
		return new DealView();
	}
	
	public void setTitles(BrowserNodeListView [] listViews) {
		listViews[0].setTitle("Deal Store");
		listViews[1].setTitle("Days");
		listViews[2].setTitle("Deals");
	}
}
