package backoffice.BOgui;

import backoffice.BOkernel.*;
import BOutilities.BOcanvas.*;

import java.awt.*;
import java.awt.event.*;

public class FrontOfficeFrame extends Frame
{

	final static private String 
		CREATE= "Create deal",
		CONNECT= "Connect to back office",
		SUBMIT= "Submit all deals",
		ABOUT= "About...",
		EXIT= "Close";
							
	protected FrontOffice office;
	protected FrontOfficeFrame officeFrame;
	protected List dealList;
	
	public FrontOfficeFrame(FrontOffice frontOffice, String title) {
		super(title);
		office= frontOffice;
		officeFrame= this;
		
		this.makeMenuBar();
		this.makeContent();
	}
	
	private void makeMenuBar() {
		MenuBar b= new MenuBar();
		Menu m= new Menu("File", true);
		MenuItem i= new MenuItem(ABOUT);
		
		ActionListener show= new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				new AboutDialog(officeFrame);
			}
		};
		i.addActionListener(show);
		
		m.add(i);
		m.addSeparator();

		i= new MenuItem(EXIT);
		
		ActionListener quitter= new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				office.quit();
			}
		};
		i.addActionListener(quitter);
		
		m.add(i);

		b.add(m);
		setMenuBar(b);
	}
	
	private void makeContent() {
			
		WindowListener wl= new WindowAdapter() {
			public void windowClosing(WindowEvent event) {
				office.quit();
			}
		};
		this.addWindowListener(wl);
		
		
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints constraint = new GridBagConstraints();
	
		setLayout(gridbag);
		
		constraint.fill = GridBagConstraints.BOTH;
		constraint.weightx = 1.0;
		constraint.weighty = 1.0;
		constraint.gridwidth =  1;    
		constraint.gridheight = 3;

		Component component= new ImageCanvas("./BOgui/BOimages/single.gif");
		gridbag.setConstraints(component, constraint);
		add(component);
		
		constraint.gridwidth = GridBagConstraints.REMAINDER;
		constraint.gridheight = 1;       
		
		Button button= new Button(CREATE);
		gridbag.setConstraints(button, constraint);		
		add(button);
		button.addActionListener(office.createListener());
		
		button= new Button(CONNECT);
		gridbag.setConstraints(button, constraint);		
		add(button); 
		button.addActionListener(office.connectListener());
		
		button= new Button(SUBMIT);
		gridbag.setConstraints(button, constraint);		
		add(button); 
		button.addActionListener(office.submitListener());
		
		dealList= new List(10);
			
		constraint.anchor= GridBagConstraints.CENTER;
		constraint.insets= new Insets(10,5,5,5);
		gridbag.setConstraints(dealList, constraint);		
		add(dealList);
		
		setSize(300,300);
		
		pack();
	}
	
	public void addDeal(BODeal deal) {
		dealList.add(deal.toString());
	}
	
	public void removeDeal(BODeal deal) {
		dealList.remove(deal.toString());
	}
	
	public void removeAllDeals() {
		dealList.removeAll();
	}
}
