package backoffice.BOkernel;

import backoffice.BOutil.*;
import BOutilities.BObrowser.*;

import java.util.*;

public class BODeal extends Object implements BrowserNode
{
	protected Date settleDate, closingDate;
	protected InstructionSet  transactionList, history;
	protected BOTransaction   inProcess;
 	
 	public BODeal(Date settleDate) {
 		transactionList= new InstructionSet();
 		history= new InstructionSet();
 		
 		this.settleDate= settleDate;
 		this.closingDate= null;
 		this.inProcess= null;
	}
	 		 	
  	public Date settleDate() {
 		return settleDate;
 	}
 	
 	public Date closingDate() {
		return closingDate;
	}
	
	public void close(Date date) {
		closingDate= date;
	}
 	
 	public boolean finished() {
		return (transactionList.size() == 0);
	}
	
 	public Date dueDate() {
 		return transactionList.first().dueDate();
 	}
	
 	public boolean isBeingProcessed() {
 		return (inProcess != null);
 	}
 	
	public void pushTransaction(BOTransaction transaction) {
 		transaction.setDeal(this);
		transactionList.insertFirst(transaction);
	}
	
	public void addTransaction(BOTransaction transaction) {
		transaction.setDeal(this);
		transactionList.insert(transaction);
	}
 	
 	public BOTransaction nextTransactionForProcessing() {
 		if(!this.isBeingProcessed()) {
 			inProcess= transactionList.checkoutFirst();
 			return inProcess;
 		}
 		return (BOTransaction) null;
 	}
 	
 	public void transactionFinished(BOTransaction done) {
 		if(done == inProcess) {
 			// history.append(inProcess);
 			history.insert(inProcess);
 			inProcess= null;
 		}
 	}
 	
 	public Enumeration transactions() {
		return transactionList.instructionSet();
	}
	
	public Enumeration history() {
		return history.instructionSet();
	}
 	
 	public BOTransaction inProcess() {
		return inProcess;
	}
	
 	public String toString() {
		String rep= "Deal(" + settleDate.toString();
		rep += "," + transactionList.toString();
		rep += ", " + history.toString();
		rep += ", " + (isBeingProcessed() ? inProcess.toString() : "not in process") + ")";
		return rep;
	}
	
		
	
	// BrowserNode interface 
	
	public BrowserNode [] getChildren() {
		return null;
	}
	
	public boolean hasContent() {
		return true;
	}
	
	public BrowserNode getContent() {
		return this;
	}
	
	public String toBrowserString() {
		return "Deal(" + settleDate.toString() + ")";
	}

}
