package backoffice.BOkernel;

import backoffice.BOutil.*;
import BOutilities.BObrowser.*;

import java.util.*;

public class BODealbase extends Object implements DateSelector
{

	private static final boolean DEBUG= true;
	
	private DealStore dealStore;
	
	public BODealbase(BackOffice backOffice) {
		String title= "Dealbase " + backOffice.tradingLine().toString();
		this.dealStore= new DealStore(title, this);
	}
	
	public void addDeal(BODeal deal) {
		if(DEBUG) System.out.println(deal.toString());
		dealStore.addDeal(deal);
	}
	
	public Vector matureDeals(Date date) {
		return dealStore.dealsBefore(date);
	}
	
	public BODeal checkoutDeal(BODeal deal) {
		dealStore.removeDeal(deal);
		return deal;
	}
	
	public Vector checkoutDeals(Vector deals) {
		Enumeration e= deals.elements();
		while(e.hasMoreElements()) 
			dealStore.removeDeal((BODeal) e.nextElement());
		return deals;
	}
	
	public Vector checkoutMatureDeals(Date date) {
		Vector v= dealStore.dealsBefore(date);
		if(DEBUG) System.out.println("### " + v.size() + " deals found for " + date.toString());
		return checkoutDeals(v);
	}
			
	public BrowserNode asBrowserNode() {
		return dealStore.asBrowserNode();
	}
	
	// interface DateSelector
	public Date date(BODeal deal) {
		return deal.dueDate();
	}
}
