package backoffice.BOkernel;

import java.util.*;

public abstract class BOProcessor extends Thread
{	
	
	protected BackOffice backOffice;
	private BOTransaction transaction;
			
	public void setBackOffice(BackOffice backOffice) {
		this.backOffice= backOffice;
	}
	
	public void run() {
		doProcess(transaction);
		BODeal deal= transaction.deal();
		deal.transactionFinished(transaction);
		
		if(deal.finished()) {
			deal.close(backOffice.environment().now());
			backOffice.archive().archiveDeal(deal);
		} else
			backOffice.dealbase().addDeal(deal);
	}

	public void process(BOTransaction transaction) {
		this.transaction= transaction;
		start();
	}
	
	public abstract void doProcess(BOTransaction transaction);
	
	public abstract boolean canProcess(BOTransaction transaction);
}

