package backoffice.BOkernel;

public abstract class BackOfficeFactory extends Object
{	
	public BODealbase createDealbase(BackOffice backOffice) {
		return new BODealbase(backOffice);
	}
	
	public BOArchive createArchive(BackOffice backOffice) {
		return new BOArchive(backOffice);
	}
	
	public BOProcessor createProcessor(BOProcessor p, BackOffice backOffice) {
		try {
			BOProcessor clone= (BOProcessor) p.getClass().newInstance();
			clone.setBackOffice(backOffice);
			return clone;
		} catch(Exception e) {}
		return null;
	}
	
	public abstract BOScheduler createScheduler(BackOffice backOffice);
	
	public abstract BOProcessor createProcessor(BackOffice backoffice);
}
