package backoffice.BOkernel;

import backoffice.BOutil.*;

import java.util.*;

public class BankSystem extends Object {
	
	private Hashtable  frontOffices;
	private Hashtable  backOffices;
	private LineManager manager;
	
	public BankSystem(LineManager manager) {
		this.manager= manager;
		this.frontOffices= new Hashtable();
		this.backOffices=  new Hashtable();
	}
	
	public void enroll(FrontOffice office) {
		frontOffices.put(office.ident(), office);
	}
	
	public void enroll(BackOffice office) {
		backOffices.put(office.tradingLine(), office);
	}
		
	public void quit() {
		// quit all front offices
		Enumeration e= frontOffices.elements();
		while(e.hasMoreElements())
			((FrontOffice) e.nextElement()).quit();
		
		// quit all back offices
		e= backOffices.elements();
		while(e.hasMoreElements())
			((BackOffice) e.nextElement()).quit();
	}
	
	public void remove(FrontOffice office) {
		frontOffices.remove(office.ident());
	}
	
	public void remove(BackOffice office) {
		backOffices.remove(office.tradingLine());
	}
	
	private TradingLine[] openTradingLines() {
		int size= backOffices.size();
		TradingLine [] lines= new TradingLine[size];
		Enumeration e= backOffices.keys();
		for( int i= 0; i < size; i++) 
			lines[i]= (TradingLine) e.nextElement();
		return lines;
	}
	
	public void connect(FrontOffice office) {
		try {
			TradingLine line= manager.select(openTradingLines());
			office.connectTo((BackOffice) backOffices.get(line));
		}
		catch ( NullPointerException e ) {
			System.out.println("No BackOffice available");
		}
	}
}
