package backoffice.BOsimulation;

import backoffice.BOkernel.*;

import java.util.*;

public class OfficeSimulationEnvironment extends Object 
	implements FrontOfficeEnvironment, BackOfficeEnvironment
{
	private BankSystem system;
	private BackOfficeFactory  bFactory;
	private FrontOfficeFactory fFactory;
	private SimulationClock clock;

	public OfficeSimulationEnvironment() {
		this.system= null;
		this.bFactory= null;
		this.fFactory= null;
		this.clock= new SimulationClock();
	};
	
	public Date now() {
		return clock.now();
	}
	
	public void subscribeTimeBeat(Observer observer) {
		clock.addObserver(observer);
	}
	
	public void unsubscribeTimeBeat(Observer observer) {
		clock.deleteObserver(observer);
	}
	
	public SimulationClock simulationClock() {
		return clock;
	}
	
	public BankSystem bankSystem() {
		return system;
	}
	
	public BackOfficeFactory backOfficeFactory() {
		return bFactory;
	}
	
	public FrontOfficeFactory frontOfficeFactory() {
		return fFactory;
	}
	
	
	// configuration interface
	
	public void setBankSystem(BankSystem system) {
		this.system= system;
	}
	
	public void setBackOfficeFactory(BackOfficeFactory factory) {
		bFactory= factory;
	}
	
	public void setFrontOfficeFactory(FrontOfficeFactory factory) {
		fFactory= factory;
	}
}
	
	
		
