package backoffice.BOtest;

import backoffice.BOkernel.*;

import java.util.Date;

public class FrontOfficeTestFactory extends FrontOfficeFactory
{
	private int transactionID;
	
	public FrontOfficeTestFactory(FrontOfficeEnvironment environment) {
		super(environment);
		transactionID= 0;
	}

	public BODeal createDeal() {
		BODeal deal= new BODeal(environment.now());
		for(int i=0; i< 5; i++)
			deal.addTransaction(createTransaction());
		return deal;
	}
	
	private Date createRandomDate(Date now) {
		double aux= (Math.random() * 10e9) + (Math.random() * 10e6);
		return new Date(Math.round(aux) + now.getTime());
	}
	
	public BOTransaction createTransaction() {
		Date date= createRandomDate(environment.now());
		return new BOTestTransaction(transactionID++, date);
	}
	
}
