package backoffice.BOutil;

import backoffice.BOkernel.*;

import java.util.*;

public class InstructionSet extends Object 
{
	private Vector collection;
	
	public InstructionSet() {
		collection= new Vector();
	}
	
	/* Inserts transaction at the place determined by its due to date. */
	public void insert(BOTransaction transaction) {
		Enumeration e= instructionSet();
		while(e.hasMoreElements()) {
			BOTransaction t= (BOTransaction) e.nextElement();
			if(transaction.dueDate().before(t.dueDate())) {
				addBefore(transaction, t);
				return;
			}
		}
		append(transaction);
	}

	/* Inserts transaction at first place. */
	public void insertFirst(BOTransaction transaction) {
		try {
			collection.insertElementAt(transaction, 0);
		} catch(ArrayIndexOutOfBoundsException e) {
			// cannot happen
		}
	}
			
	public BOTransaction checkoutFirst() {
		BOTransaction first= null;
		try {
			first= (BOTransaction) collection.firstElement();
			collection.removeElementAt(0);
		} catch (ArrayIndexOutOfBoundsException e) {
			// do nothing
		}
		return first;
	}
	
	public BOTransaction first() {
		BOTransaction first= null;
		try {
			first= (BOTransaction) collection.firstElement();
		} catch(NoSuchElementException e) {
			// do nothing
		}
		return first;
	}
			
	public Enumeration instructionSet() {
		return collection.elements();
	}
	
	public int size() {
		return collection.size();
	} 
	
	public String toString() {
		String rep= "InstructionSet(";
		Enumeration e= instructionSet();
		if(!e.hasMoreElements())
			rep += ")";
		else {
			rep += "\n\t" + e.nextElement().toString();
			while(e.hasMoreElements())
				rep += ",\n\t" + e.nextElement().toString();
			rep += "\n)";
		}
		return rep;
	}
	
	
	protected void addBefore(BOTransaction t1, BOTransaction t2) {
		int index= collection.indexOf(t2);
		try {
			collection.insertElementAt(t1, index);
		} catch(ArrayIndexOutOfBoundsException e) {
			// cannot happen
		}
	}
	
	protected void append(BOTransaction transaction) {
		collection.addElement(transaction);
	}
			
}
